unit Choose;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls , ComCtrls;

type
  TChooseForm = class(TForm)
    TreeView1: TTreeView;
    ChooseLabel1: TLabel;
    ProgressLabel: TLabel;
    OkButton: TButton;
    CancelButton: TButton;
    procedure FormShow(Sender: TObject);
    procedure OkButtonClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
  private
  public
    FileName : string;
  end;

var
  ChooseForm: TChooseForm;

implementation

uses Main;

{$R *.DFM}

procedure TChooseForm.FormShow(Sender: TObject);
begin
  with MainForm do
  if GetDisks then begin
    TreeView1.Items.Clear;
    TransfFile := '';
    TransfMode := tmDiskList;
    ClientText := 'GetDisks'#13;
    GetDisks := False;
    ProgressLabel.Caption := 'Collecting...';
  end;
end;

procedure TChooseForm.OkButtonClick(Sender: TObject);
var
  Temp : string;
  FName : string;
  Node : TTreeNode;
  I : Word;
begin
  with TreeView1 do begin
    Temp := '';
    Node := Selected;
    while Node <> nil do begin
      if Temp = '' then begin // Filename to assign Temp.
        if MainForm.RemoteVer <= '1.51' then
          Temp := Node.Text;
        FName := Node.Text;
        I := Length(FName);
        while (I >= 1) and (FName[I] <> '(') do
          Dec(I);
        if (I > 1) and (Temp = '') then
          Temp := Copy(FName, 1, I - 2);
      end else // Directory to insert in Temp.
        Temp := Node.Text + '\' + Temp;
      Node := Node.Parent;
    end;
  end;
  FileName := Temp;
end;

procedure TChooseForm.CancelButtonClick(Sender: TObject);
begin
  FileName := '';
end;

end.
