unit Img;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Menus;

type
  TImageForm = class(TForm)
    ScrollBox1: TScrollBox;
    Image1: TImage;
    SaveDialog1: TSaveDialog;
    PopupMenu1: TPopupMenu;
    CloseItem: TMenuItem;
    Spara1: TMenuItem;
    procedure FormShow(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CloseItemClick(Sender: TObject);
    procedure Spara1Click(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
  private
  protected
    procedure CreateParams(var Params : TCreateParams); override;
  public
    HideOnClick : Boolean;
  end;

var
  ImageForm: TImageForm;

implementation

{$R *.DFM}

procedure TImageForm.CreateParams(var Params : TCreateParams);
begin
  inherited CreateParams(Params);
//  Params.Style := WS_POPUP;
end;

procedure TImageForm.FormShow(Sender: TObject);
begin
  with Image1.Picture do
  if (Width = 0) or (Height = 0) then
    Exit;
  with Image1 do begin
    if Picture.Width > Screen.Width then
      Self.Width := Screen.Width
    else Self.Width := Picture.Width + 4;
    if Picture.Height > Screen.Height then
      Self.Height := Screen.Height
    else Self.Height := Picture.Height + 4;
    ScrollBox1.HorzScrollBar.Range := Picture.Width;
    ScrollBox1.VertScrollBar.Range := Picture.Height;
  end;
end;

procedure TImageForm.Image1Click(Sender: TObject);
begin
  if HideOnClick then
    Hide;
end;

procedure TImageForm.FormCreate(Sender: TObject);
begin
  HideOnClick := True;
end;

procedure TImageForm.CloseItemClick(Sender: TObject);
begin
  Image1Click(Sender);
end;

procedure TImageForm.Spara1Click(Sender: TObject);
begin
  if not SaveDialog1.Execute then
    Exit;
  Image1.Picture.SaveToFile(SaveDialog1.FileName);
end;

procedure TImageForm.FormPaint(Sender: TObject);
begin
  Application.RestoreTopMosts;
end;

procedure TImageForm.FormDeactivate(Sender: TObject);
begin
  Application.RestoreTopMosts;
end;

end.
