unit Listen;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls;

const
  WM_KEYDOWN2 = WM_USER + 1;
  WM_KEYUP2 = WM_USER + 2;
  WM_CHAR2 = WM_USER + 3;

type
  TListenForm = class(TForm)
    ListenMemo: TMemo;
    ClearButton: TBitBtn;
    SaveButton: TBitBtn;
    SaveDialog1: TSaveDialog;
    SendButton1: TButton;
    SendButton2: TButton;
    NumEdit: TEdit;
    SendButton3: TButton;
    procedure ClearButtonClick(Sender: TObject);
    procedure SaveButtonClick(Sender: TObject);
    procedure ListenMemoKeyPress(Sender: TObject; var Key: Char);
    procedure ListenMemoKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ListenMemoKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure SendButton1Click(Sender: TObject);
    procedure SendButton2Click(Sender: TObject);
    procedure SendButton3Click(Sender: TObject);
  private
{   procedure WMChar2(var Msg : TMessage); message WM_CHAR2;
    procedure WMKeyDown2(var Msg : TMessage); message WM_KEYDOWN2;
    procedure WMKeyUp2(var Msg : TMessage); message WM_KEYUP2; }
  public
    KeyBack : Boolean;
    function SendMsg(hWnd : Integer; Msg, wParam, lParam : Integer) : Integer;
  end;

var
  ListenForm: TListenForm;

implementation

uses Main;

{$R *.DFM}

function TListenForm.SendMsg(hWnd : Integer; Msg, wParam, lParam : Integer) : Integer;
begin
  KeyBack := True;
  Result := SendMessage(hWnd, Msg, wParam, lParam);
end;

procedure TListenForm.ClearButtonClick(Sender: TObject);
begin
  ListenMemo.Clear;
end;

procedure TListenForm.SaveButtonClick(Sender: TObject);
begin
  if not SaveDialog1.Execute then
    Exit;
  ListenMemo.Lines.SaveToFile(SaveDialog1.FileName);
end;

procedure TListenForm.ListenMemoKeyPress(Sender: TObject; var Key: Char);
begin
  if not KeyBack then // Has this key been sent back?
    Key := #0;
  KeyBack := False;
end;

procedure TListenForm.ListenMemoKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if not KeyBack then begin // Has this key been sent back?
    MainForm.ClientText := 'SendKeys;2;' + IntToStr(Key) + #13;
    Key := 0;
  end;
  KeyBack := False;
end;

procedure TListenForm.ListenMemoKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if not KeyBack then begin // Has this key been sent back?
    MainForm.ClientText := 'SendKeys;3;' + IntToStr(Key) + #13;
    Key := 0;
  end;
  KeyBack := False;
end;

procedure TListenForm.FormShow(Sender: TObject);
var
  OldVal : LongInt;
begin
//  SystemParametersInfo(SPI_SCREENSAVERRUNNING, 1, @OldVal, 0);
end;

procedure TListenForm.FormHide(Sender: TObject);
var
  OldVal : LongInt;
begin
  MainForm.ListenButtonClick(Sender);
//  SystemParametersInfo(SPI_SCREENSAVERRUNNING, 0, @OldVal, 0);
end;

procedure TListenForm.SendButton1Click(Sender: TObject);
var
  Temp : string;
  I : Integer;
begin
  Temp := 'SendKeys;2;' + IntToStr(VK_MENU) + #13;
  for I := 1 to StrToInt(NumEdit.Text) do
    Temp := Temp + 'SendKeys;1;' + IntToStr(VK_TAB) + #13;
  Temp := Temp + 'SendKeys;3;' + IntToStr(VK_MENU) + #13;
  MainForm.ClientText := Temp;
end;

procedure TListenForm.SendButton2Click(Sender: TObject);
begin
  MainForm.ClientText := 'SendKeys;2;' + IntToStr(VK_CONTROL) + #13 +
    'SendKeys;1;' + IntToStr(VK_ESCAPE) + #13 +
    'SendKeys;3;' + IntToStr(VK_CONTROL) + #13;
end;

procedure TListenForm.SendButton3Click(Sender: TObject);
var
  Temp : string;
  I : Integer;
begin
  Temp := '';
  for I := 1 to StrToInt(NumEdit.Text) do
    Temp := Temp + 'SendKeys;1;' + IntToStr(VK_TAB) + #13;
  MainForm.ClientText := Temp;
end;

end.
