//----------------------------------------------------------------------------
//  Project quickfyre
//  The BRiGADE
//  Copyright  1997. All Rights Reserved.
//
//  SUBSYSTEM:    quickfyre.apx Application
//  FILE:         mailingdialog.cpp
//  AUTHOR:       Pri$m
//
//  OVERVIEW
//  ~~~~~~~~
//  Source file for implementation of TMailingDialog (TDialog).
//
//----------------------------------------------------------------------------
#include <owl/pch.h>

#include "mailingdialog.h"


DEFINE_RESPONSE_TABLE1(TMailingDialog, TDialog)
//{{TMailingDialogRSP_TBL_BEGIN}}
  EV_WM_SHOWWINDOW,
  EV_BN_CLICKED(IDCANCEL, StopButtonClicked),
  EV_MESSAGE(WS_ASYNC, HandleWinsockMessage),
//{{TMailingDialogRSP_TBL_END}}
END_RESPONSE_TABLE;


//{{TMailingDialog Implementation}}


TMailingDialog::TMailingDialog(TWindow* parent, MailStruct MStruc, TResId resId, TModule* module)
:
    TDialog(parent, resId, module)
{
  // INSERT>> Your constructor code here.
 MailDetails = MStruc;

 OutputEdit = new TListBox(this, IDC_SENTLISTBOX);
 StopButton = new TButton(this, IDCANCEL);
 MailingStatus = new TStatic(this, IDC_MAILINGSTATUSTEXT);
 ProgressGauge = new TGauge(this, "%d%%", 208, 31, 141, 263, 20);
 ProgressGauge->SetNativeUse(nuNever);
 ProgressGauge->SetRange(0, 100);

 MThread = NULL;
}


TMailingDialog::~TMailingDialog()
{
  Destroy(IDCANCEL);

  // INSERT>> Your destructor code here.
  if(ProgressGauge != NULL) delete ProgressGauge;
  if(MailingStatus != NULL) delete MailingStatus;
  if(OutputEdit != NULL) delete OutputEdit;
  if(StopButton != NULL) delete StopButton;

  if(MThread != NULL)
   {
    MThread->TerminateAndWait();
    delete MThread;
   }
}


void TMailingDialog::EvShowWindow(bool show, uint status)
{
    TDialog::EvShowWindow(show, status);

  // INSERT>> Your code here.
 MailDialogInterface MailDlg;
 MailDlg.ProgressGauge = ProgressGauge;
 MailDlg.MailingStatus = MailingStatus;
 MailDlg.OutputEdit = OutputEdit;
 MailDlg.MailButton = StopButton;
 MailDlg.Handle = GetHandle();

 MThread = new MailThread(MailDetails, MailDlg);
 MThread->Start();
}

void TMailingDialog::StopButtonClicked()
{
  // INSERT>> Your code here.
 if(MThread->GetStatus() == TThread::Finished)
  {
   CloseWindow();
  }
 else
  {
   MThread->Terminate();
  }  
}

LRESULT TMailingDialog::HandleWinsockMessage(WPARAM, LPARAM lParam)
{
 WORD WSAEvent = WSAGETSELECTEVENT(lParam);
  
 switch(WSAEvent)
  {
   case FD_READ:
     if(MThread != NULL)
       MThread->HandleReceive();
    break;
 
   case FD_CLOSE:
     //MThread->HandleClose();
    break;  
  }
 return 0; 
}
