//----------------------------------------------------------------------------
//  Project quickfyre
//  The BRiGADE
//  Copyright  1997. All Rights Reserved.
//
//  SUBSYSTEM:    quickfyre.apx Application
//  FILE:         mailingdialog.h
//  AUTHOR:       Pri$m
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TMailingDialog (TDialog).
//
//----------------------------------------------------------------------------
#if !defined(mailingdialog_h)              // Sentry, use file only if it's not already included.
#define mailingdialog_h

#include <owl/dialog.h>
#include <owl/static.h>

#include <owl/commctrl.h>
#include <owl/gauge.h>
#include <owl/listbox.h>
#include <owl/button.h>

#include "quickfyreapp.rh"            // Definition of all resources.
#include "MailThread.h"

//{{TDialog = TMailingDialog}}
class TMailingDialog : public TDialog {
  public:
    TMailingDialog(TWindow* parent, MailStruct MStruc, TResId resId = IDD_MAILINGDLG, TModule* module = 0);
    virtual ~TMailingDialog();
//{{TMailingDialogRSP_TBL_BEGIN}}
  protected:
    void EvShowWindow(bool show, uint status);
    MailStruct MailDetails;
    TStatic  *MailingStatus;
    TGauge   *ProgressGauge;  
    TButton  *StopButton;
    TListBox *OutputEdit;

    MailThread *MThread;
    void StopButtonClicked();
    LRESULT HandleWinsockMessage(WPARAM, LPARAM);
//{{TMailingDialogRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TMailingDialog);
};    //{{TMailingDialog}}


#endif  // mailingdialog_h sentry.

