//----------------------------------------------------------------------------
//  Project QuickFyre
//  The BRiGADE
//  Copyright  1997. All Rights Reserved.
//
//  SUBSYSTEM:    QuickFyre Application
//  FILE:         quickfyreapp.cpp
//  AUTHOR:       Pri$m
//
//  OVERVIEW
//  ~~~~~~~~
//  Source file for implementation of TQuickFyreApp (TApplication).
//
//----------------------------------------------------------------------------

#include <owl/pch.h>

#include <stdio.h>

#include "quickfyreapp.h"
#include "quickfyredlgclient.h"                        // Definition of client class.

//{{TQuickFyreApp Implementation}}

TQuickFyreApp::TQuickFyreApp() : TApplication("-= QuickFyre =-")
{

  // INSERT>> Your constructor code here.
  Daemon = NULL;

}


TQuickFyreApp::~TQuickFyreApp()
{
  // INSERT>> Your destructor code here.
 if(Daemon != NULL) delete Daemon;
}


void TQuickFyreApp::InitMainWindow()
{
  Daemon = new WinSockDaemon();

  if(Daemon->Error()) 
   {
    MessageBox(NULL, "Couldn't load winsock.dll", "Error!", MB_ICONEXCLAMATION | MB_OK);
   }

  if (nCmdShow != SW_HIDE)
    nCmdShow = (nCmdShow != SW_SHOWMINNOACTIVE) ? SW_SHOWNORMAL : nCmdShow;

  TSDIDecFrame* frame = new TSDIDecFrame(0, GetName(), 0, true);
  frame->SetFlag(wfShrinkToClient);

  // Override the default window style for the main window.
  
  frame->Attr.Style |= WS_BORDER | WS_CAPTION | WS_MINIMIZEBOX | WS_SYSMENU | WS_VISIBLE;
  frame->Attr.Style &= ~(WS_CHILD | WS_CLIPCHILDREN | WS_MAXIMIZEBOX | WS_THICKFRAME);

  frame->SetIcon(this, IDI_SDIAPPLICATION);
  frame->SetIconSm(this, IDI_SDIAPPLICATION);

  SetMainWindow(frame);


  EnableCtl3d(true);
}



//{{TSDIDecFrame Implementation}}


TSDIDecFrame::TSDIDecFrame(TWindow* parent, const char far* title, TWindow* clientWnd, bool trackMenuSelection, TModule* module)
:
  TDecoratedFrame(parent, title, !clientWnd ? new TQuickFyreDlgClient(0) : clientWnd, trackMenuSelection, module)
{
  // INSERT>> Your constructor code here.

}


TSDIDecFrame::~TSDIDecFrame()
{
  // INSERT>> Your destructor code here.

}


void TSDIDecFrame::SetupWindow()
{
  TDecoratedFrame::SetupWindow();

  // INSERT>> Your code here.
}

int OwlMain(int , char* [])
{
  TQuickFyreApp   app;
  return app.Run();
} 
