//----------------------------------------------------------------------------
//  Project QuickFyre
//  The BRiGADE
//  Copyright  1997. All Rights Reserved.
//
//  SUBSYSTEM:    QuickFyre Application
//  FILE:         quickfyredlgclient.h
//  AUTHOR:       Pri$m
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TQuickFyreDlgClient (TDialog).
//
//----------------------------------------------------------------------------
#if !defined(quickfyredlgclient_h)              // Sentry, use file only if it's not already included.
#define quickfyredlgclient_h

#include "quickfyreapp.rh"                  // Definition of all resources.


#include <owl/commctrl.h>
#include <owl/edit.h>
#include <owl/updown.h>
#include <owl/gdiobjec.h>

//{{TDialog = TQuickFyreDlgClient}}
class TQuickFyreDlgClient : public TDialog {
  public:
    TQuickFyreDlgClient(TWindow* parent, TResId resId = IDD_CLIENT, TModule* module = 0);
    virtual ~TQuickFyreDlgClient();


//{{TQuickFyreDlgClientVIRTUAL_BEGIN}}
  public:
    virtual void SetupWindow();
//{{TQuickFyreDlgClientVIRTUAL_END}}

//{{TQuickFyreDlgClientRSP_TBL_BEGIN}}
  protected:
    void MailClicked();
    void AboutClicked();

    int CheckForInputErrors(char *message);

    TEdit *SenderEdit, *ReceiverEdit, *SubjectEdit,
          *ServerEdit, *CopiesEdit, *TextEdit;
    TUpDown *CopiesUpDown;      

    TDib *QuickFyreDIB;
    TPalette *QFPal;
    
    int EvCreate(CREATESTRUCT far& createStruct);
    void EvShowWindow(bool show, uint status);
    void EvPaint();
//{{TQuickFyreDlgClientRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TQuickFyreDlgClient);
};    //{{TQuickFyreDlgClient}}


#endif  // quickfyredlgclient_h sentry.
