/****************************************************************************\
* Eye          : Thread class for the Eye                                    *
* Programmer   : Pri$m                                                       *
* Date         : 28th October 1997                                           *
* Language     : C++                                                         *
* Compiler     : Borland C++ v5.0                                            *
* Memory Model : Flat (32 bit)                                               *
\****************************************************************************/

#include <owl/appdict.h>
#include <owl/applicat.h>
#include <math.h>

#include "eye.rh"
#include "eye.h"

//Member function implementations
EyeThread::EyeThread(TWindow *TargetWin, int xx, int yy)
{
 HINSTANCE HInst = OWLGetAppDictionary().GetApplication()->GetHandle();
 
 EyeDib[0] = new TDib(HInst, (TResId)IDB_EYE0);
 EyeDib[1] = new TDib(HInst, (TResId)IDB_EYE1);
 EyeDib[2] = new TDib(HInst, (TResId)IDB_EYE2);
 EyeDib[3] = new TDib(HInst, (TResId)IDB_EYE3);
 EyeDib[4] = new TDib(HInst, (TResId)IDB_EYE4);
 EyeDib[5] = new TDib(HInst, (TResId)IDB_EYE5);
 EyeDib[6] = new TDib(HInst, (TResId)IDB_EYE6);
 EyeDib[7] = new TDib(HInst, (TResId)IDB_EYE7);

 EyeDibPal = new TPalette(*EyeDib[0]);

 Target = TargetWin;

 CurrentEye = -1;

 x = xx;
 y = yy;
}

EyeThread::~EyeThread()
{
 for(int j = 0; j < 8; j++)
  delete EyeDib[j];

 delete EyeDibPal; 
}
 
void EyeThread::PaintEye()
{
 if(CurrentEye == -1) return;

 TClientDC TargetDC(Target->HWindow);

 TargetDC.SelectObject(*EyeDibPal);
 TargetDC.RealizePalette();

 TMemoryDC MemDC;
 TBitmap CurrEyeBit(*(EyeDib[CurrentEye]), EyeDibPal);

 MemDC.SelectObject(CurrEyeBit);

 TargetDC.BitBlt(x - (CurrEyeBit.Width() / 2), 
   y - (CurrEyeBit.Height() / 2), 
   CurrEyeBit.Width(), 
   CurrEyeBit.Height(), 
   MemDC, 0, 0, SRCCOPY);
}

void EyeThread::CalcEyePos()
{
 static TPoint CurrentP;
 
 Target->GetCursorPos(CurrentP);

 TPoint MyPoint(x, y);
 Target->ClientToScreen(MyPoint);
 
 TPoint CurrentPos(CurrentP.X() - MyPoint.X(), CurrentP.Y() - MyPoint.Y());

 int currplace;
 int LengthOpposite = CurrentPos.X();
 int LengthAdjacent = CurrentPos.Y();
 double HypLength = sqrt((LengthOpposite * LengthOpposite) + (LengthAdjacent * LengthAdjacent));

 if(HypLength == 0) currplace = 0;
 else
  {
   double SineValue = LengthOpposite / HypLength;

   if(SineValue > -0.2 && SineValue < 0.2)
    {
     if(CurrentPos.Y() > 0) currplace = 4;
      else currplace = 0;
    }

   else if(SineValue > 0.8 && SineValue < 1.2)
    {
     if(CurrentPos.X() > 0) currplace = 2;
      else currplace = 6;
    } 
   else if(SineValue >= 0)
    {
     if(CurrentPos.Y() > 0) currplace = 3;
      else currplace = 1;
    } 
   else
    {
     if(CurrentPos.Y() > 0) currplace = 5;
      else currplace = 7;
    }
  }
                      
 if((currplace != CurrentEye) && (!ShouldTerminate()))
  {
   CurrentEye = currplace;
   PaintEye();
  }
}

int EyeThread::Run()
{
 while(!ShouldTerminate())
  {
   CalcEyePos();
  }
  
 return 0;
}
