#ifndef __ICMP__H__

typedef unsigned long   IPAddr;     // An IP address.
typedef unsigned long   IPMask;     // An IP subnet mask.
typedef unsigned long   IP_STATUS;  // Status code returned from IP APIs.

typedef struct ip_option_information {
    unsigned char      Ttl;             // Time To Live
    unsigned char      Tos;             // Type Of Service
    unsigned char      Flags;           // IP header flags
    unsigned char      OptionsSize;     // Size in bytes of options data
    unsigned char FAR *OptionsData;     // Pointer to options data
} IP_OPTION_INFORMATION, FAR *PIP_OPTION_INFORMATION; /* ip_option_information */

typedef struct icmp_echo_reply {
    IPAddr                 Address;         // Replying address
    unsigned long          Status;          // Reply status
    unsigned long          RoundTripTime;   // RTT in milliseconds
    unsigned short         DataSize;        // Echo data size
    unsigned short         Reserved;        // Reserved for system use
    void FAR              *Data;            // Pointer to the echo data
    IP_OPTION_INFORMATION Options;         // Reply options
} ICMP_ECHO_REPLY, FAR *PICMP_ECHO_REPLY;

typedef HANDLE (WINAPI *ICMPCREATE)(VOID);
typedef BOOL (WINAPI *ICMPCLOSE)(HANDLE);
typedef DWORD (WINAPI *ICMPSEND)(HANDLE,IPAddr,
                LPVOID,WORD,PIP_OPTION_INFORMATION,
                LPVOID,DWORD,DWORD);
                
#define __ICMP__H__
#endif
