/****************************************************************************\
* MailThread   : Thread class for QuickFyre                                  *
* Programmer   : Pri$m                                                       *
* Date         : 24th October 1997                                           *
* Language     : C++                                                         *
* Compiler     : Borland C++ v5.0                                            *
* Memory Model : Flat (32 bit)                                               *
\****************************************************************************/

#include "MailThread.h"

MailThread::MailThread(MailStruct MStruc, MailDialogInterface MDialog)
 : TThread()
{
 MailInfo = MStruc;
 MailDialog = MDialog;
 Mailer = NULL;

 LineIn = false;
}

MailThread::~MailThread()
{
 if(Mailer != NULL) delete Mailer;
}

void MailThread::WaitForLine()
{
 LineIn = false;

 while(!LineIn) {};
}
 
void MailThread::HandleReceive()
{
 char In[300];

 if(Mailer != NULL)
  Mailer->Get(In, 300);

 LineIn = true; 
}
 
int MailThread::Run()
{
 int CopiesSent = 0;
 float Percentage;
 char Message[50];
 char intmess[10];
 char Total[10];
 char SendString[150];
  
 itoa(MailInfo.Copies, Total, 10);

 Mailer = new NetSocketMailer(MailInfo.Server, 25, MailDialog.OutputEdit);

 if(Mailer->Error()) 
  {
   MailDialog.MailingStatus->SetText("Couldn't create socket!");
   MailDialog.MailButton->SetCaption("OK");

   delete Mailer;
   Mailer = NULL;

   return 0;
  }

 MailDialog.MailButton->EnableWindow(false); 

 MailDialog.MailingStatus->SetText("Connecting to server ..."); 
  
 Mailer->Connect();

 int nRet = WSAAsyncSelect(Mailer->GetSocket(), MailDialog.Handle,
  WS_ASYNC, (FD_READ | FD_CLOSE));
 
 if((Mailer->Error()) || (nRet == SOCKET_ERROR))
  {
   MailDialog.MailingStatus->SetText("Couldn't connect to server.");
   MailDialog.MailButton->SetCaption("OK");
   MailDialog.MailButton->EnableWindow(true);
   
   delete Mailer;
   Mailer = NULL;

   return 0;
  }

 WaitForLine();
  
 MailDialog.MailingStatus->SetText("Connected to server."); 

 MailDialog.MailButton->EnableWindow(true);
   
 while(!ShouldTerminate() && (CopiesSent < MailInfo.Copies))
  {
   strcpy(Message, "Mailing copy ");
   itoa(CopiesSent + 1, intmess, 10);
   strcat(Message, intmess);
   strcat(Message, " of ");
   strcat(Message, Total);
   strcat(Message, " ...");
   MailDialog.MailingStatus->SetText(Message);

   Mailer->Send("RSET\n", 5);
   WaitForLine();
   
   strcpy(SendString, "MAIL FROM:");
   strcat(SendString, MailInfo.Sender);
   strcat(SendString, "\n");
   
   Mailer->Send(SendString, strlen(SendString));
   WaitForLine();
   
   strcpy(SendString, "RCPT TO:");
   strcat(SendString, MailInfo.Receiver);
   strcat(SendString, "\n");

   Mailer->Send(SendString, strlen(SendString));
   WaitForLine();
   
   Mailer->Send("DATA\n", 5);
   WaitForLine();
   
   strcpy(SendString, "subject:");
   strcat(SendString, MailInfo.Subject);
   strcat(SendString, "\n");

   Mailer->Send(SendString, strlen(SendString));
         
   Mailer->Send(MailInfo.Text, strlen(MailInfo.Text));
         
   Mailer->Send("\n.\n", 3);
   WaitForLine();
     
   Sleep(30);

   CopiesSent++;
   Percentage = 100 * CopiesSent / MailInfo.Copies;

   MailDialog.ProgressGauge->SetValue(Percentage);
  }
  
 MailDialog.MailingStatus->SetText("Closing connection ..."); 
 Sleep(1000);
 Mailer->Send("QUIT\n", 5);
 Sleep(1000);
    
 Mailer->Disconnect();
   
 MailDialog.MailingStatus->SetText("Connection closed.");
 MailDialog.MailButton->SetCaption("OK");
  
 delete Mailer;
 Mailer = NULL;
  
 return 0; 
}
