#ifndef __MAILTHREAD__H__

//MailThread.h - header file for the MailThread class

#include <owl/gauge.h>
#include <owl/static.h>
#include <owl/listbox.h>
#include <owl/button.h>

#include <classlib/thread.h>

#include "netsockmail.h"

struct MailDialogInterface
{
 TGauge *ProgressGauge;
 TStatic *MailingStatus;
 TListBox *OutputEdit;
 TButton *MailButton;
 HWND Handle;
};

struct MailStruct
{
 char Receiver[70];
 char Sender[70];
 char Server[70];
 char Subject[150];
 char Text[700];
 int Copies;
};

class MailThread : public TThread
{
 public:
  MailThread(MailStruct MStruc, MailDialogInterface MDialog);
  ~MailThread();

  void HandleReceive();
 
 protected:
  int Run();
  void WaitForLine();

  bool LineIn;

  MailStruct MailInfo;
  MailDialogInterface MailDialog;
  NetSocketMailer *Mailer;
};

#define __MAILTHREAD__H__
#endif