/****************************************************************************\
* NetSocket    : Wrapper class for Windows Sockets                           *
* Programmer   : Pri$m                                                       *
* Date         : 22nd July 1997                                              *
* Language     : C++                                                         *
* Compiler     : Borland C++ v5.0                                            *
* Memory Model : Flat (32 bit)                                               *
\****************************************************************************/

//Includes
#include "netsocket.h"
#include <string.h>

//Class Member Function Definitions
NetSocket::NetSocket()
{
 ErrorCode = 0;
}

NetSocket::NetSocket(char *address, short port)
{
 ErrorCode = 0;
 SetAddress(address, port);
 OpenSocket();
}

void NetSocket::SetAddress(char *address, short port)
{
 Port = port;
 strcpy(Address, address);
}

void NetSocket::OpenSocket()
{
 ThisSocket = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
 if(ThisSocket == INVALID_SOCKET) ErrorCode = 1;
}

void NetSocket::Connect()
{
 struct sockaddr_in blah;
 struct hostent *he;
 memset((char *)&blah,'0', sizeof(blah));

 blah.sin_family=AF_INET;
 blah.sin_addr.s_addr=inet_addr(Address);
 blah.sin_port=htons(Port);

 he = gethostbyname(Address);

 if (he != NULL) {
		memcpy((char *)&blah.sin_addr, he->h_addr, he->h_length );
	}
	else
    {
		if ((blah.sin_addr.s_addr = inet_addr(Address)) < 0)
      {
		 ErrorCode = 1;
		 return;
		}
	 }

 if (connect(ThisSocket,(struct sockaddr *)&blah,sizeof(struct sockaddr))==-1) {
		ErrorCode = 1;
		closesocket(ThisSocket);
      ThisSocket = INVALID_SOCKET;
		return;
	}   
}

void NetSocket::Disconnect()
{
 if(ThisSocket != INVALID_SOCKET) closesocket(ThisSocket);
 ThisSocket = INVALID_SOCKET;
}

void NetSocket::Send(char *data, int len, int flags)
{
 send(ThisSocket, data, len, flags);
}

void NetSocket::Get(char *data, int len, int flags)
{
 recv(ThisSocket, data, len, flags);
}

void NetSocket::Listen(HWND hWnd)
{
 sockaddr_in LocalName;

 ThisSocket = socket(AF_INET, SOCK_STREAM, 0);

 if(ThisSocket == INVALID_SOCKET)
  {
   ErrorCode = 1;
   return;
  }
 
 if(WSAAsyncSelect(ThisSocket, hWnd, WS_ASYNC, 
   FD_ACCEPT | FD_READ | FD_OOB | FD_CLOSE) == SOCKET_ERROR)
   {
    ErrorCode = 1;
    closesocket(ThisSocket);
    ThisSocket = INVALID_SOCKET;
    return;
   }

  LocalName.sin_family = PF_INET;
  LocalName.sin_port = (u_short) htons((u_short)Port); 
  LocalName.sin_addr.s_addr = 0;
  
  if(bind(ThisSocket, (LPSOCKADDR)(&LocalName), sizeof(sockaddr)) == SOCKET_ERROR)
   {
    ErrorCode = 1;
    closesocket(ThisSocket);
    ThisSocket = INVALID_SOCKET;
    return;
   }

  if(listen(ThisSocket, 1) == INVALID_SOCKET)
   {
    ErrorCode = 1;
    closesocket(ThisSocket);
    ThisSocket = INVALID_SOCKET;
    return;
   } 
 }

int NetSocket::Error()
{
 int cCode = ErrorCode;
 ErrorCode = 0;
 
 return cCode;
}
