//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "pfthread.h"
//---------------------------------------------------------------------------
//   Important: Methods and properties of objects in VCL can only be
//   used in a method called using Synchronize, for example:
//
//      Synchronize(UpdateCaption);
//
//   where UpdateCaption could look like:
//
//      void __fastcall PingFloodThread::UpdateCaption()
//      {
//        Form1->Caption = "Updated in a thread";
//      }
//---------------------------------------------------------------------------
__fastcall PingFloodThread::PingFloodThread()
	: TThread(true)
{
 Data = NULL;
 Pinger = new PingSocket();
 Pinger->OpenSocket();
}
//---------------------------------------------------------------------------
__fastcall PingFloodThread::~PingFloodThread()
{
 if(Data != NULL) free(Data);
 
 Pinger->CloseSocket();  
 delete Pinger;
}
//---------------------------------------------------------------------------
void __fastcall PingFloodThread::Execute()
{
	//---- Place thread code here ----
  while(!Terminated)
   {
    Pinger->Send(Data, PacketSize);
   } 
}
//---------------------------------------------------------------------------
void __fastcall PingFloodThread::SetSpecs(char*address, int psize)
{
 strcpy(PingAddress, address);
 PacketSize = psize;

 Pinger->SetAddress(PingAddress);
  
 if(Data != NULL) free(Data);

 Data = (char*)malloc(PacketSize);

 Pinger->CheckSend(Data, PacketSize);
} 

int __fastcall PingFloodThread::Error()
{
 return Pinger->Error();
}

