 /****************************************************************************\
* PingSocket   : Wrapper class for Windows Sockets (Ping)                    *
* Programmer   : Pri$m                                                       *
* Date         : 23rd July 1997                                              *
* Language     : C++                                                         *
* Compiler     : Borland C++ v5.0                                            *
* Memory Model : Flat (32 bit)                                               *
\****************************************************************************/

//Includes
#include "pingsocket.h"
#include <string.h>

//Global Handle Declaration
HMODULE PingDllHandle;

//Class Member Function Definitions
PingSocket::PingSocket()
{
 ErrorCode = 0;
 ReplyData = NULL;
 
 GetProcs();
}

PingSocket::PingSocket(char *address)
{
 ErrorCode = 0;
 ReplyData = NULL;
 GetProcs();
 
 SetAddress(address);
 OpenSocket();
}

void PingSocket::GetProcs()
{
 CreateFile = (ICMPCREATE) GetProcAddress(PingDllHandle, "IcmpCreateFile");
 CloseHandle = (ICMPCLOSE) GetProcAddress(PingDllHandle, "IcmpCloseHandle");
 SendTheEcho = (ICMPSEND) GetProcAddress(PingDllHandle, "IcmpSendEcho");            

 if((CreateFile == NULL) || (CloseHandle == NULL) || (SendTheEcho == NULL))
  ErrorCode = 1;
}

void PingSocket::SetAddress(char *address)
{
 strcpy(Address, address);
 Addr = inet_addr(Address);
}

void PingSocket::OpenSocket()
{
 ThisSocketHandle = (*CreateFile)();
}


void PingSocket::CloseSocket()
{
 (*CloseHandle)(ThisSocketHandle);
}

void PingSocket::Send(char *data, int len)
{
 (*SendTheEcho)(ThisSocketHandle, Addr, data, len, NULL, ReplyData, len + 500, len*5);
}

void PingSocket::CheckSend(char *data, int len)
{
 if(ReplyData != NULL) free(ReplyData);
   ReplyData = (unsigned char*)malloc(len*2 + 1000);
  

 DWORD Result = (*SendTheEcho)(ThisSocketHandle, Addr, data, len, NULL, ReplyData, len + 400, len*10);

 if(Result < 1)
  {
   ErrorCode = GetLastError();
   //if(ErrorCode == 11010) ErrorCode = 0; 
  } 
}

int PingSocket::Error()
{
 int cCode = ErrorCode;
 ErrorCode = 0;
 
 return cCode;
}

PingSocket::~PingSocket()
{
 if(ReplyData != NULL)
  free(ReplyData);
}