//NetSocket.h - the header file for the NetSocket Class.

#ifndef __PINGSOCKET__H__

//Includes
#include <winsock.h>
#include <windows.h>

#include "icmp.h"
//Global external declaration
extern HMODULE PingDllHandle;

//Class Declaration
class PingSocket
{
 public:
  PingSocket();
  PingSocket(char *address);
  ~PingSocket();

  void SetAddress(char *address);
  void OpenSocket();
  void CloseSocket();
  
  void Send(char *data, int len);
  void CheckSend(char *data, int len);
  
  int Error();

 private:
  void GetProcs();

  HANDLE ThisSocketHandle;
  char Address[40];
  u_long Addr;
  int ErrorCode;
  unsigned char *ReplyData;

  ICMPCREATE CreateFile;
  ICMPCLOSE  CloseHandle;
  ICMPSEND   SendTheEcho;
};

#define __PINGSOCKET__H__
#endif